//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/ColorCDLForACESLog_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/ColorCDLForACESLog.glsl by quoteFile.
//
const char* ColorCDLForACESLog_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Academy Color Decision List 1.2\n"
"//\n"
"//  For CDL in ACES Log space\n"
"//\n"
"\n"
"vec3 LinearToACESLog (const in vec3 aces)\n"
"{\n"
"    const vec3 aceslog_unity = vec3(32768.0);\n"
"    const vec3 aceslog_xperstop = vec3(2048.0);\n"
"    vec3 aces_denorm_trans = vec3(pow( 2.0, -15.0));\n"
"    vec3 aces_denorm_fake0 = vec3(pow( 2.0, -16.0));\n"
"\n"
"    bvec3 t0 = lessThan(aces, vec3(0.0));\n"
"    bvec3 t1 = lessThan(aces, aces_denorm_trans);\n"
"  \n"
"    /* compress denorms into 1 stop below last norm stop */\n"
"    vec3 c1 = aces_denorm_fake0 + ( aces / 2.0);\n"
"    c1 = mix(aces, c1, vec3(t1));\n"
"\n"
"    vec3 acesLog = (log2(c1) * aceslog_xperstop + aceslog_unity);\n"
"  \n"
"    return mix(acesLog, vec3(0.0), vec3(t0));\n"
"}\n"
"\n"
"\n"
"vec3 ACESLogToLinear (const in vec3 aceslog)\n"
"{\n"
"    const vec3 aceslog_unity = vec3(32768.0);\n"
"    const vec3 aceslog_xperstop = vec3(2048.0);\n"
"    vec3 aces_denorm_trans = vec3(pow( 2.0, -15.0));\n"
"    vec3 aces_denorm_fake0 = vec3(pow( 2.0, -16.0));\n"
"\n"
"    vec3 aces = pow( vec3(2.0), (aceslog - aceslog_unity) / aceslog_xperstop);\n"
"  \n"
"    // if (aces < aces_denorm_trans) \n"
"    bvec3 t = lessThan(aces, aces_denorm_trans);\n"
"\n"
"    vec3 c1 = (aces - aces_denorm_fake0) * 2.0;\n"
"    return mix(aces, c1, vec3(t));\n"
"}\n"
"\n"
"vec4 ColorCDLForACESLog (const in vec4 P, \n"
"                         const in vec3 slope,\n"
"                         const in vec3 offset,\n"
"                         const in vec3 power,\n"
"                         const in float saturation,\n"
"                         const in vec3 lumaCoefficients,\n"
"                         const in vec3 refLow,  // 12860.643\n"
"                         const in vec3 refHigh, // 48742.586\n"
"                         const in mat4 toACES,\n"
"                         const in mat4 fromACES,\n"
"                         const in float minClamp,\n"
"                         const in float maxClamp)\n"
"{\n"
"    vec4 aces = toACES * vec4(P.rgb, 1.0);\n"
"    vec3 aceslog = LinearToACESLog(max(aces.rgb, vec3(0.0)));\n"
"\n"
"    vec3 cdl = (aceslog - refLow) / (refHigh - refLow);\n"
"\n"
"    cdl = pow(clamp(cdl * slope + offset, minClamp, maxClamp), power);\n"
"\n"
"    aceslog = refLow + cdl * (refHigh - refLow);\n"
"\n"
"    cdl = ACESLogToLinear(aceslog);\n"
"\n"
"    cdl = cdl * vec3(saturation) +\n"
"                    vec3(cdl.r * lumaCoefficients.r +\n"
"	                 cdl.g * lumaCoefficients.g +\n"
"	                 cdl.b * lumaCoefficients.b) * vec3(1.0 - saturation) ;\n"
"\n"
"\n"
"    aces = fromACES * vec4(cdl, 1.0);\n"
"\n"
"    return vec4(aces.rgb, P.a);\n"
"}\n"
"\n"
"\n"
;
