//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/LensWarpRadialAndTangential_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/LensWarpRadialAndTangential.glsl by quoteFile.
//
const char* LensWarpRadialAndTangential_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"// Adapted from http://en.wikipedia.org/wiki/Distortion_%28optics%29\n"
"// or OpenCV http://opencv.willowgarage.com/documentation/camera_calibration_and_3d_reconstruction.html\n"
"// x corrected = x( 1 + k1 * r^2 + k2 * r^4 + k3 * r^6)\n"
"// y corrected = y( 1 + k1 * r^2 + k2 * r^4 + k3 * r^6)\n"
"// x corrected tan = 2p2*x*y + p1(r^2 + 2x^2)]\n"
"// y corrected tan = p2*(r^2 + 2*y^2) + 2 * p1 * x * y\n"
"// \n"
"// distortion centre, offset is specified within range [-1... 1]\n"
"//\n"
"\n"
"\n"
"vec4 LensWarpRadialAndTangential (const in inputImage in0,\n"
"                                  const in float k1,\n"
"                                  const in float k2,\n"
"                                  const in float k3,\n"
"                                  const in float d,\n"
"                                  const in float p1,\n"
"                                  const in float p2,\n"
"                                  const in vec2  offset,\n"
"                                  const in vec2  f)\n"
"{\n"
"    vec2 cp = offset - in0.st;        // current pixel from center\n"
"\n"
"    vec2 ncp = cp / f;  	      // normalized current pixel\n"
"\n"
"    float ncp_x2 = ncp.x * ncp.x;\n"
"    float ncp_y2 = ncp.y * ncp.y;\n"
"    float ncp_xy = ncp.x * ncp.y;\n"
"\n"
"    float rdest = ncp_x2 + ncp_y2; // radius\n"
"\n"
"    // Radial distortion\n"
"    float rsrc  =  ((k3 * rdest + k2) * rdest + k1) * rdest + d; // new radius\n"
"\n"
"    // Tangential distortion\n"
"    float xtan = 2.0 * p2 * (ncp_xy) + p1 * (rdest + 2.0 * ncp_x2);\n"
"    float ytan = p2 * (rdest + 2.0 * ncp_y2) + 2.0 * p1 * ncp_xy;\n"
"\n"
"    vec2 op = cp - f * (ncp * vec2(rsrc)  + vec2(xtan, ytan));\n"
"\n"
"    return in0(op);\n"
"}\n"
"\n"
;
