//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QAbstractListModelType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QMimeDataType.h>
#include <MuQt6/QModelIndexType.h>
#include <MuQt6/QVariantType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QAbstractListModel::~MuQt_QAbstractListModel()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QAbstractListModel::MuQt_QAbstractListModel(Pointer muobj,
                                                     const CallEnvironment* ce,
                                                     QObject* parent)
        : QAbstractListModel(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QAbstractListModelType>(
            c->internName("qt.QAbstractListModel"));
    }

    bool MuQt_QAbstractListModel::dropMimeData(const QMimeData* data,
                                               Qt::DropAction action, int row,
                                               int column,
                                               const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractListModel::dropMimeData(data, action, row, column,
                                                    parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, data, "qt.QMimeData"));
            args[2] = Value(int(action));
            args[3] = Value(row);
            args[4] = Value(column);
            args[5] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::dropMimeData(data, action, row, column,
                                                    parent);
        }
    }

    Qt::ItemFlags MuQt_QAbstractListModel::flags(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractListModel::flags(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (Qt::ItemFlags)(rval._int);
        }
        else
        {
            return QAbstractListModel::flags(index);
        }
    }

    QModelIndex MuQt_QAbstractListModel::index(int row, int column,
                                               const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractListModel::index(row, column, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(column);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::index(row, column, parent);
        }
    }

    QModelIndex MuQt_QAbstractListModel::sibling(int row, int column,
                                                 const QModelIndex& idx) const
    {
        if (!_env)
            return QAbstractListModel::sibling(row, column, idx);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(column);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, idx, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::sibling(row, column, idx);
        }
    }

    QModelIndex MuQt_QAbstractListModel::buddy(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractListModel::buddy(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::buddy(index);
        }
    }

    bool MuQt_QAbstractListModel::canDropMimeData(
        const QMimeData* data, Qt::DropAction action, int row, int column,
        const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractListModel::canDropMimeData(data, action, row,
                                                       column, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, data, "qt.QMimeData"));
            args[2] = Value(int(action));
            args[3] = Value(row);
            args[4] = Value(column);
            args[5] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::canDropMimeData(data, action, row,
                                                       column, parent);
        }
    }

    bool MuQt_QAbstractListModel::canFetchMore(const QModelIndex& parent) const
    {
        if (!_env)
            return QAbstractListModel::canFetchMore(parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::canFetchMore(parent);
        }
    }

    bool MuQt_QAbstractListModel::clearItemData(const QModelIndex& index)
    {
        if (!_env)
            return QAbstractListModel::clearItemData(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::clearItemData(index);
        }
    }

    QVariant MuQt_QAbstractListModel::data(const QModelIndex& index,
                                           int role) const // pure virtual
    {
        if (!_env)
            return defaultValue<QVariant>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(role);
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return defaultValue<QVariant>();
        }
    }

    void MuQt_QAbstractListModel::fetchMore(const QModelIndex& parent)
    {
        if (!_env)
        {
            QAbstractListModel::fetchMore(parent);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractListModel::fetchMore(parent);
        }
    }

    QVariant MuQt_QAbstractListModel::headerData(int section,
                                                 Qt::Orientation orientation,
                                                 int role) const
    {
        if (!_env)
            return QAbstractListModel::headerData(section, orientation, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(section);
            args[2] = Value(int(orientation));
            args[3] = Value(role);
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::headerData(section, orientation, role);
        }
    }

    bool MuQt_QAbstractListModel::insertColumns(int column, int count,
                                                const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractListModel::insertColumns(column, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::insertColumns(column, count, parent);
        }
    }

    bool MuQt_QAbstractListModel::insertRows(int row, int count,
                                             const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractListModel::insertRows(row, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::insertRows(row, count, parent);
        }
    }

    QModelIndexList MuQt_QAbstractListModel::match(const QModelIndex& start,
                                                   int role,
                                                   const QVariant& value,
                                                   int hits,
                                                   Qt::MatchFlags flags) const
    {
        if (!_env)
            return QAbstractListModel::match(start, role, value, hits, flags);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, start, "qt.QModelIndex"));
            args[2] = Value(role);
            args[3] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[4] = Value(hits);
            args[5] = Value(int(flags));
            Value rval = _env->call(F, args);
            return qmodelindexlist(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::match(start, role, value, hits, flags);
        }
    }

    QMimeData*
    MuQt_QAbstractListModel::mimeData(const QModelIndexList& indexes) const
    {
        if (!_env)
            return QAbstractListModel::mimeData(indexes);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqmodelindexlist(c, indexes));
            Value rval = _env->call(F, args);
            return object<QMimeData>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::mimeData(indexes);
        }
    }

    QStringList MuQt_QAbstractListModel::mimeTypes() const
    {
        if (!_env)
            return QAbstractListModel::mimeTypes();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return qstringlist(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::mimeTypes();
        }
    }

    bool MuQt_QAbstractListModel::moveColumns(
        const QModelIndex& sourceParent, int sourceColumn, int count,
        const QModelIndex& destinationParent, int destinationChild)
    {
        if (!_env)
            return QAbstractListModel::moveColumns(sourceParent, sourceColumn,
                                                   count, destinationParent,
                                                   destinationChild);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqtype<QModelIndexType>(c, sourceParent, "qt.QModelIndex"));
            args[2] = Value(sourceColumn);
            args[3] = Value(count);
            args[4] = Value(makeqtype<QModelIndexType>(c, destinationParent,
                                                       "qt.QModelIndex"));
            args[5] = Value(destinationChild);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::moveColumns(sourceParent, sourceColumn,
                                                   count, destinationParent,
                                                   destinationChild);
        }
    }

    bool MuQt_QAbstractListModel::moveRows(const QModelIndex& sourceParent,
                                           int sourceRow, int count,
                                           const QModelIndex& destinationParent,
                                           int destinationChild)
    {
        if (!_env)
            return QAbstractListModel::moveRows(sourceParent, sourceRow, count,
                                                destinationParent,
                                                destinationChild);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(6);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqtype<QModelIndexType>(c, sourceParent, "qt.QModelIndex"));
            args[2] = Value(sourceRow);
            args[3] = Value(count);
            args[4] = Value(makeqtype<QModelIndexType>(c, destinationParent,
                                                       "qt.QModelIndex"));
            args[5] = Value(destinationChild);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::moveRows(sourceParent, sourceRow, count,
                                                destinationParent,
                                                destinationChild);
        }
    }

    bool MuQt_QAbstractListModel::removeColumns(int column, int count,
                                                const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractListModel::removeColumns(column, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::removeColumns(column, count, parent);
        }
    }

    bool MuQt_QAbstractListModel::removeRows(int row, int count,
                                             const QModelIndex& parent)
    {
        if (!_env)
            return QAbstractListModel::removeRows(row, count, parent);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            args[2] = Value(count);
            args[3] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::removeRows(row, count, parent);
        }
    }

    int MuQt_QAbstractListModel::rowCount(
        const QModelIndex& parent) const // pure virtual
    {
        if (!_env)
            return defaultValue<int>();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return defaultValue<int>();
        }
    }

    bool MuQt_QAbstractListModel::setData(const QModelIndex& index,
                                          const QVariant& value, int role)
    {
        if (!_env)
            return QAbstractListModel::setData(index, value, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[3] = Value(role);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::setData(index, value, role);
        }
    }

    bool MuQt_QAbstractListModel::setHeaderData(int section,
                                                Qt::Orientation orientation,
                                                const QVariant& value, int role)
    {
        if (!_env)
            return QAbstractListModel::setHeaderData(section, orientation,
                                                     value, role);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(5);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(section);
            args[2] = Value(int(orientation));
            args[3] = Value(makeqtype<QVariantType>(c, value, "qt.QVariant"));
            args[4] = Value(role);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractListModel::setHeaderData(section, orientation,
                                                     value, role);
        }
    }

    void MuQt_QAbstractListModel::sort(int column, Qt::SortOrder order)
    {
        if (!_env)
        {
            QAbstractListModel::sort(column, order);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            args[2] = Value(int(order));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractListModel::sort(column, order);
        }
    }

    QSize MuQt_QAbstractListModel::span(const QModelIndex& index) const
    {
        if (!_env)
            return QAbstractListModel::span(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractListModel::span(index);
        }
    }

    Qt::DropActions MuQt_QAbstractListModel::supportedDragActions() const
    {
        if (!_env)
            return QAbstractListModel::supportedDragActions();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (Qt::DropActions)(rval._int);
        }
        else
        {
            return QAbstractListModel::supportedDragActions();
        }
    }

    Qt::DropActions MuQt_QAbstractListModel::supportedDropActions() const
    {
        if (!_env)
            return QAbstractListModel::supportedDropActions();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (Qt::DropActions)(rval._int);
        }
        else
        {
            return QAbstractListModel::supportedDropActions();
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QAbstractListModelType::QAbstractListModelType(Context* c, const char* name,
                                                   Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QAbstractListModelType::~QAbstractListModelType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer
    QAbstractListModel_QAbstractListModel_QObject(Thread& NODE_THREAD,
                                                  Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QAbstractListModel* w = object<QAbstractListModel>(widget))
        {
            QAbstractListModelType* type =
                c->findSymbolOfTypeByQualifiedName<QAbstractListModelType>(
                    c->internName("qt.QAbstractListModel"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QAbstractListModel_QAbstractListModel_QObject(
            NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer
    qt_QAbstractListModel_QAbstractListModel_QAbstractListModel_QAbstractListModel_QObject(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QObject* arg1 = object<QObject>(param_parent);
        setobject(param_this,
                  new MuQt_QAbstractListModel(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    bool
    qt_QAbstractListModel_dropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_data,
        int param_action, int param_row, int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_data);
        Qt::DropAction arg2 = (Qt::DropAction)(param_action);
        int arg3 = (int)(param_row);
        int arg4 = (int)(param_column);
        const QModelIndex arg5 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::dropMimeData(arg1, arg2, arg3,
                                                            arg4, arg5)
                   : arg0->dropMimeData(arg1, arg2, arg3, arg4, arg5);
    }

    int qt_QAbstractListModel_flags_int_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0) ? int(arg0->QAbstractListModel::flags(arg1))
                                  : int(arg0->flags(arg1));
    }

    Pointer
    qt_QAbstractListModel_index_QModelIndex_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QAbstractListModel::index(arg1, arg2, arg3),
                         "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(
                         c, arg0->index(arg1, arg2, arg3), "qt.QModelIndex");
    }

    Pointer
    qt_QAbstractListModel_sibling_QModelIndex_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, Pointer param_idx)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_idx);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QAbstractListModel::sibling(arg1, arg2, arg3),
                         "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(
                         c, arg0->sibling(arg1, arg2, arg3), "qt.QModelIndex");
    }

    Pointer
    qt_QAbstractListModel_buddy_QModelIndex_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QAbstractListModel::buddy(arg1),
                         "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(c, arg0->buddy(arg1),
                                                "qt.QModelIndex");
    }

    bool
    qt_QAbstractListModel_canDropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_data,
        int param_action, int param_row, int param_column, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_data);
        Qt::DropAction arg2 = (Qt::DropAction)(param_action);
        int arg3 = (int)(param_row);
        int arg4 = (int)(param_column);
        const QModelIndex arg5 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::canDropMimeData(arg1, arg2, arg3,
                                                               arg4, arg5)
                   : arg0->canDropMimeData(arg1, arg2, arg3, arg4, arg5);
    }

    bool qt_QAbstractListModel_canFetchMore_bool_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0) ? arg0->QAbstractListModel::canFetchMore(arg1)
                                  : arg0->canFetchMore(arg1);
    }

    bool
    qt_QAbstractListModel_clearItemData_bool_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::clearItemData(arg1)
                   : arg0->clearItemData(arg1);
    }

    Pointer
    qt_QAbstractListModel_data_QVariant_QAbstractListModel_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        int arg2 = (int)(param_role);
        return makeqtype<QVariantType>(c, arg0->data(arg1, arg2),
                                       "qt.QVariant");
    }

    void qt_QAbstractListModel_fetchMore_void_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        if (isMuQtObject(arg0))
            arg0->QAbstractListModel::fetchMore(arg1);
        else
            arg0->fetchMore(arg1);
    }

    Pointer
    qt_QAbstractListModel_headerData_QVariant_QAbstractListModel_int_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_section,
        int param_orientation, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_section);
        Qt::Orientation arg2 = (Qt::Orientation)(param_orientation);
        int arg3 = (int)(param_role);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c,
                         arg0->QAbstractListModel::headerData(arg1, arg2, arg3),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(
                         c, arg0->headerData(arg1, arg2, arg3), "qt.QVariant");
    }

    bool
    qt_QAbstractListModel_insertColumns_bool_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_column);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::insertColumns(arg1, arg2, arg3)
                   : arg0->insertColumns(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractListModel_insertRows_bool_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::insertRows(arg1, arg2, arg3)
                   : arg0->insertRows(arg1, arg2, arg3);
    }

    Pointer
    qt_QAbstractListModel_match_qt__QModelIndexBSB_ESB__QAbstractListModel_QModelIndex_int_QVariant_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_start,
        int param_role, Pointer param_value, int param_hits, int param_flags)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_start);
        int arg2 = (int)(param_role);
        const QVariant arg3 = getqtype<QVariantType>(param_value);
        int arg4 = (int)(param_hits);
        Qt::MatchFlags arg5 = (Qt::MatchFlags)(param_flags);
        return isMuQtObject(arg0)
                   ? makeqmodelindexlist(c, arg0->QAbstractListModel::match(
                                                arg1, arg2, arg3, arg4, arg5))
                   : makeqmodelindexlist(
                         c, arg0->match(arg1, arg2, arg3, arg4, arg5));
    }

    Pointer
    qt_QAbstractListModel_mimeData_QMimeData_QAbstractListModel_qt__QModelIndexBSB_ESB_(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_indexes)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndexList arg1 = qmodelindexlist(param_indexes);
        return isMuQtObject(arg0)
                   ? makeinstance<QMimeDataType>(
                         c, arg0->QAbstractListModel::mimeData(arg1),
                         "qt.QMimeData")
                   : makeinstance<QMimeDataType>(c, arg0->mimeData(arg1),
                                                 "qt.QMimeData");
    }

    Pointer qt_QAbstractListModel_mimeTypes_stringBSB_ESB__QAbstractListModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        return isMuQtObject(arg0)
                   ? makestringlist(c, arg0->QAbstractListModel::mimeTypes())
                   : makestringlist(c, arg0->mimeTypes());
    }

    bool
    qt_QAbstractListModel_moveColumns_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceColumn, int param_count,
        Pointer param_destinationParent, int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceColumn);
        int arg3 = (int)(param_count);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::moveColumns(arg1, arg2, arg3,
                                                           arg4, arg5)
                   : arg0->moveColumns(arg1, arg2, arg3, arg4, arg5);
    }

    bool
    qt_QAbstractListModel_moveRows_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_sourceParent,
        int param_sourceRow, int param_count, Pointer param_destinationParent,
        int param_destinationChild)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_sourceParent);
        int arg2 = (int)(param_sourceRow);
        int arg3 = (int)(param_count);
        const QModelIndex arg4 =
            getqtype<QModelIndexType>(param_destinationParent);
        int arg5 = (int)(param_destinationChild);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::moveRows(arg1, arg2, arg3, arg4,
                                                        arg5)
                   : arg0->moveRows(arg1, arg2, arg3, arg4, arg5);
    }

    bool
    qt_QAbstractListModel_removeColumns_bool_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_column);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::removeColumns(arg1, arg2, arg3)
                   : arg0->removeColumns(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractListModel_removeRows_bool_QAbstractListModel_int_int_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_count, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_count);
        const QModelIndex arg3 = getqtype<QModelIndexType>(param_parent);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::removeRows(arg1, arg2, arg3)
                   : arg0->removeRows(arg1, arg2, arg3);
    }

    int qt_QAbstractListModel_rowCount_int_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        return arg0->rowCount(arg1);
    }

    bool
    qt_QAbstractListModel_setData_bool_QAbstractListModel_QModelIndex_QVariant_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        Pointer param_value, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        const QVariant arg2 = getqtype<QVariantType>(param_value);
        int arg3 = (int)(param_role);
        return isMuQtObject(arg0)
                   ? arg0->QAbstractListModel::setData(arg1, arg2, arg3)
                   : arg0->setData(arg1, arg2, arg3);
    }

    bool
    qt_QAbstractListModel_setHeaderData_bool_QAbstractListModel_int_int_QVariant_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_section,
        int param_orientation, Pointer param_value, int param_role)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_section);
        Qt::Orientation arg2 = (Qt::Orientation)(param_orientation);
        const QVariant arg3 = getqtype<QVariantType>(param_value);
        int arg4 = (int)(param_role);
        return isMuQtObject(arg0) ? arg0->QAbstractListModel::setHeaderData(
                                        arg1, arg2, arg3, arg4)
                                  : arg0->setHeaderData(arg1, arg2, arg3, arg4);
    }

    void qt_QAbstractListModel_sort_void_QAbstractListModel_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_order)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        int arg1 = (int)(param_column);
        Qt::SortOrder arg2 = (Qt::SortOrder)(param_order);
        if (isMuQtObject(arg0))
            arg0->QAbstractListModel::sort(arg1, arg2);
        else
            arg0->sort(arg1, arg2);
    }

    Pointer qt_QAbstractListModel_span_QSize_QAbstractListModel_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QAbstractListModel::span(arg1), "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->span(arg1), "qt.QSize");
    }

    int qt_QAbstractListModel_supportedDragActions_int_QAbstractListModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        return isMuQtObject(arg0)
                   ? int(arg0->QAbstractListModel::supportedDragActions())
                   : int(arg0->supportedDragActions());
    }

    int qt_QAbstractListModel_supportedDropActions_int_QAbstractListModel(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractListModel* arg0 = object<QAbstractListModel>(param_this);
        return isMuQtObject(arg0)
                   ? int(arg0->QAbstractListModel::supportedDropActions())
                   : int(arg0->supportedDropActions());
    }

    static NODE_IMPLEMENTATION(_n_QAbstractListModel0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_QAbstractListModel_QAbstractListModel_QAbstractListModel_QObject(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_dropMimeData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_dropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, int),
                NODE_ARG(5, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_flags0, int)
    {
        NODE_RETURN(
            qt_QAbstractListModel_flags_int_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_index0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_index_QModelIndex_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sibling0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_sibling_QModelIndex_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_buddy0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_buddy_QModelIndex_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_canDropMimeData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_canDropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, int),
                NODE_ARG(5, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_canFetchMore0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_canFetchMore_bool_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clearItemData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_clearItemData_bool_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_data0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_data_QVariant_QAbstractListModel_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_fetchMore0, void)
    {
        qt_QAbstractListModel_fetchMore_void_QAbstractListModel_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_headerData0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_headerData_QVariant_QAbstractListModel_int_int_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, int)));
    }

    static NODE_IMPLEMENTATION(_n_insertColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_insertColumns_bool_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_insertRows_bool_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_match0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_match_qt__QModelIndexBSB_ESB__QAbstractListModel_QModelIndex_int_QVariant_int_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_mimeData0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_mimeData_QMimeData_QAbstractListModel_qt__QModelIndexBSB_ESB_(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_mimeTypes0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_mimeTypes_stringBSB_ESB__QAbstractListModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_moveColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_moveColumns_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_moveRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_moveRows_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, Pointer),
                NODE_ARG(5, int)));
    }

    static NODE_IMPLEMENTATION(_n_removeColumns0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_removeColumns_bool_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeRows0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_removeRows_bool_QAbstractListModel_int_int_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_rowCount0, int)
    {
        NODE_RETURN(
            qt_QAbstractListModel_rowCount_int_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_setData_bool_QAbstractListModel_QModelIndex_QVariant_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer), NODE_ARG(3, int)));
    }

    static NODE_IMPLEMENTATION(_n_setHeaderData0, bool)
    {
        NODE_RETURN(
            qt_QAbstractListModel_setHeaderData_bool_QAbstractListModel_int_int_QVariant_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
                NODE_ARG(2, int), NODE_ARG(3, Pointer), NODE_ARG(4, int)));
    }

    static NODE_IMPLEMENTATION(_n_sort0, void)
    {
        qt_QAbstractListModel_sort_void_QAbstractListModel_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_span0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractListModel_span_QSize_QAbstractListModel_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_supportedDragActions0, int)
    {
        NODE_RETURN(
            qt_QAbstractListModel_supportedDragActions_int_QAbstractListModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_supportedDropActions0, int)
    {
        NODE_RETURN(
            qt_QAbstractListModel_supportedDropActions_int_QAbstractListModel(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    void QAbstractListModelType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QAbstractListModel_QAbstractListModel_QObject,
                                Return, ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QAbstractListModel", _n_QAbstractListModel0, None, Compiled,
                qt_QAbstractListModel_QAbstractListModel_QAbstractListModel_QAbstractListModel_QObject,
                Return, "qt.QAbstractListModel", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "parent", "qt.QObject"), End),
            _func[0] = new MemberFunction(
                c, "dropMimeData", _n_dropMimeData0, None, Compiled,
                qt_QAbstractListModel_dropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "data", "qt.QMimeData"),
                new Param(c, "action", "int"), new Param(c, "row", "int"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[1] = new MemberFunction(
                c, "flags", _n_flags0, None, Compiled,
                qt_QAbstractListModel_flags_int_QAbstractListModel_QModelIndex,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[2] = new MemberFunction(
                c, "index", _n_index0, None, Compiled,
                qt_QAbstractListModel_index_QModelIndex_QAbstractListModel_int_int_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "row", "int"),
                new Param(c, "column", "int", Value((int)0)),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[3] = new MemberFunction(
                c, "sibling", _n_sibling0, None, Compiled,
                qt_QAbstractListModel_sibling_QModelIndex_QAbstractListModel_int_int_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "idx", "qt.QModelIndex"), End),
            _func[4] = new MemberFunction(
                c, "buddy", _n_buddy0, None, Compiled,
                qt_QAbstractListModel_buddy_QModelIndex_QAbstractListModel_QModelIndex,
                Return, "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[5] = new MemberFunction(
                c, "canDropMimeData", _n_canDropMimeData0, None, Compiled,
                qt_QAbstractListModel_canDropMimeData_bool_QAbstractListModel_QMimeData_int_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "data", "qt.QMimeData"),
                new Param(c, "action", "int"), new Param(c, "row", "int"),
                new Param(c, "column", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[6] = new MemberFunction(
                c, "canFetchMore", _n_canFetchMore0, None, Compiled,
                qt_QAbstractListModel_canFetchMore_bool_QAbstractListModel_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[7] = new MemberFunction(
                c, "clearItemData", _n_clearItemData0, None, Compiled,
                qt_QAbstractListModel_clearItemData_bool_QAbstractListModel_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[8] = new MemberFunction(
                c, "data", _n_data0, None, Compiled,
                qt_QAbstractListModel_data_QVariant_QAbstractListModel_QModelIndex_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "role", "int", Value((int)Qt::DisplayRole)), End),
            _func[9] = new MemberFunction(
                c, "fetchMore", _n_fetchMore0, None, Compiled,
                qt_QAbstractListModel_fetchMore_void_QAbstractListModel_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[10] = new MemberFunction(
                c, "headerData", _n_headerData0, None, Compiled,
                qt_QAbstractListModel_headerData_QVariant_QAbstractListModel_int_int_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "section", "int"),
                new Param(c, "orientation", "int"),
                new Param(c, "role", "int", Value((int)Qt::DisplayRole)), End),
            _func[11] = new MemberFunction(
                c, "insertColumns", _n_insertColumns0, None, Compiled,
                qt_QAbstractListModel_insertColumns_bool_QAbstractListModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "column", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[12] = new MemberFunction(
                c, "insertRows", _n_insertRows0, None, Compiled,
                qt_QAbstractListModel_insertRows_bool_QAbstractListModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "row", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            // MISSING: itemData ("QMap<int, QVariant>"; QAbstractListModel
            // this, QModelIndex index)
            _func[13] = new MemberFunction(
                c, "match", _n_match0, None, Compiled,
                qt_QAbstractListModel_match_qt__QModelIndexBSB_ESB__QAbstractListModel_QModelIndex_int_QVariant_int_int,
                Return, "qt.QModelIndex[]", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "start", "qt.QModelIndex"),
                new Param(c, "role", "int"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "hits", "int", Value((int)1)),
                new Param(c, "flags", "int",
                          Value((int)Qt::MatchFlags(Qt::MatchStartsWith
                                                    | Qt::MatchWrap))),
                End),
            _func[14] = new MemberFunction(
                c, "mimeData", _n_mimeData0, None, Compiled,
                qt_QAbstractListModel_mimeData_QMimeData_QAbstractListModel_qt__QModelIndexBSB_ESB_,
                Return, "qt.QMimeData", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "indexes", "qt.QModelIndex[]"), End),
            _func[15] = new MemberFunction(
                c, "mimeTypes", _n_mimeTypes0, None, Compiled,
                qt_QAbstractListModel_mimeTypes_stringBSB_ESB__QAbstractListModel,
                Return, "string[]", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"), End),
            _func[16] = new MemberFunction(
                c, "moveColumns", _n_moveColumns0, None, Compiled,
                qt_QAbstractListModel_moveColumns_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceColumn", "int"),
                new Param(c, "count", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            _func[17] = new MemberFunction(
                c, "moveRows", _n_moveRows0, None, Compiled,
                qt_QAbstractListModel_moveRows_bool_QAbstractListModel_QModelIndex_int_int_QModelIndex_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "sourceParent", "qt.QModelIndex"),
                new Param(c, "sourceRow", "int"), new Param(c, "count", "int"),
                new Param(c, "destinationParent", "qt.QModelIndex"),
                new Param(c, "destinationChild", "int"), End),
            // MISSING: multiData (void; QAbstractListModel this, QModelIndex
            // index, "QModelRoleDataSpan" roleDataSpan)
            _func[18] = new MemberFunction(
                c, "removeColumns", _n_removeColumns0, None, Compiled,
                qt_QAbstractListModel_removeColumns_bool_QAbstractListModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "column", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[19] = new MemberFunction(
                c, "removeRows", _n_removeRows0, None, Compiled,
                qt_QAbstractListModel_removeRows_bool_QAbstractListModel_int_int_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "row", "int"), new Param(c, "count", "int"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            // MISSING: roleNames ("QHash<int, QByteArray>"; QAbstractListModel
            // this)
            _func[20] = new MemberFunction(
                c, "rowCount", _n_rowCount0, None, Compiled,
                qt_QAbstractListModel_rowCount_int_QAbstractListModel_QModelIndex,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "parent", "qt.QModelIndex"), End),
            _func[21] = new MemberFunction(
                c, "setData", _n_setData0,
                None, Compiled,
                qt_QAbstractListModel_setData_bool_QAbstractListModel_QModelIndex_QVariant_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "role", "int", Value((int)Qt::EditRole)), End),
            _func[22] = new MemberFunction(
                c, "setHeaderData", _n_setHeaderData0, None, Compiled,
                qt_QAbstractListModel_setHeaderData_bool_QAbstractListModel_int_int_QVariant_int,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "section", "int"),
                new Param(c, "orientation", "int"),
                new Param(c, "value", "qt.QVariant"),
                new Param(c, "role", "int", Value((int)Qt::EditRole)), End),
            // MISSING: setItemData (bool; QAbstractListModel this, QModelIndex
            // index, "const QMap<int, QVariant> &" roles)
            _func[23] = new MemberFunction(
                c, "sort", _n_sort0, None,
                Compiled,
                qt_QAbstractListModel_sort_void_QAbstractListModel_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "column", "int"),
                new Param(c, "order", "int", Value((int)Qt::AscendingOrder)),
                End),
            _func[24] = new MemberFunction(
                c, "span", _n_span0, None,
                Compiled,
                qt_QAbstractListModel_span_QSize_QAbstractListModel_QModelIndex,
                Return, "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[25] = new MemberFunction(
                c, "supportedDragActions",
                _n_supportedDragActions0, None, Compiled,
                qt_QAbstractListModel_supportedDragActions_int_QAbstractListModel,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"), End),
            _func[26] = new MemberFunction(
                c, "supportedDropActions",
                _n_supportedDropActions0, None, Compiled,
                qt_QAbstractListModel_supportedDropActions_int_QAbstractListModel,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractListModel"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QAbstractListModel::staticMetaObject, propExclusions);
    }

} // namespace Mu
