//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QButtonGroupType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QAbstractButtonType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QButtonGroup::~MuQt_QButtonGroup()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QButtonGroup::MuQt_QButtonGroup(Pointer muobj,
                                         const CallEnvironment* ce,
                                         QObject* parent)
        : QButtonGroup(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QButtonGroupType>(
            c->internName("qt.QButtonGroup"));
    }

    bool MuQt_QButtonGroup::event(QEvent* e)
    {
        if (!_env)
            return QButtonGroup::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QButtonGroup::event(e);
        }
    }

    bool MuQt_QButtonGroup::eventFilter(QObject* watched, QEvent* event)
    {
        if (!_env)
            return QButtonGroup::eventFilter(watched, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QObjectType>(c, watched, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QButtonGroup::eventFilter(watched, event);
        }
    }

    void MuQt_QButtonGroup::customEvent(QEvent* event)
    {
        if (!_env)
        {
            QButtonGroup::customEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QButtonGroup::customEvent(event);
        }
    }

    void MuQt_QButtonGroup::timerEvent(QTimerEvent* event)
    {
        if (!_env)
        {
            QButtonGroup::timerEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTimerEventType>(c, event, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QButtonGroup::timerEvent(event);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QButtonGroupType::QButtonGroupType(Context* c, const char* name,
                                       Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QButtonGroupType::~QButtonGroupType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QButtonGroup_QButtonGroup_QObject(Thread& NODE_THREAD,
                                                     Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QButtonGroup* w = object<QButtonGroup>(widget))
        {
            QButtonGroupType* type =
                c->findSymbolOfTypeByQualifiedName<QButtonGroupType>(
                    c->internName("qt.QButtonGroup"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QButtonGroup_QButtonGroup_QObject(NODE_THREAD,
                                                      NODE_ARG(0, Pointer)));
    }

    Pointer qt_QButtonGroup_QButtonGroup_QButtonGroup_QButtonGroup_QObject(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QObject* arg1 = object<QObject>(param_parent);
        setobject(param_this,
                  new MuQt_QButtonGroup(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    void qt_QButtonGroup_addButton_void_QButtonGroup_QAbstractButton_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_button,
        int param_id)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QAbstractButton* arg1 = object<QAbstractButton>(param_button);
        int arg2 = (int)(param_id);
        arg0->addButton(arg1, arg2);
    }

    Pointer qt_QButtonGroup_button_QAbstractButton_QButtonGroup_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_id)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        int arg1 = (int)(param_id);
        return makeinstance<QAbstractButtonType>(c, arg0->button(arg1),
                                                 "qt.QAbstractButton");
    }

    Pointer qt_QButtonGroup_checkedButton_QAbstractButton_QButtonGroup(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        return makeinstance<QAbstractButtonType>(c, arg0->checkedButton(),
                                                 "qt.QAbstractButton");
    }

    int qt_QButtonGroup_checkedId_int_QButtonGroup(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        return arg0->checkedId();
    }

    int qt_QButtonGroup_id_int_QButtonGroup_QAbstractButton(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_button)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QAbstractButton* arg1 = object<QAbstractButton>(param_button);
        return arg0->id(arg1);
    }

    void qt_QButtonGroup_removeButton_void_QButtonGroup_QAbstractButton(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_button)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QAbstractButton* arg1 = object<QAbstractButton>(param_button);
        arg0->removeButton(arg1);
    }

    void qt_QButtonGroup_setId_void_QButtonGroup_QAbstractButton_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_button,
        int param_id)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QAbstractButton* arg1 = object<QAbstractButton>(param_button);
        int arg2 = (int)(param_id);
        arg0->setId(arg1, arg2);
    }

    bool qt_QButtonGroup_event_bool_QButtonGroup_QEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0) ? arg0->QButtonGroup::event(arg1)
                                  : arg0->event(arg1);
    }

    bool qt_QButtonGroup_eventFilter_bool_QButtonGroup_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_watched,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QObject* arg1 = object<QObject>(param_watched);
        QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0) ? arg0->QButtonGroup::eventFilter(arg1, arg2)
                                  : arg0->eventFilter(arg1, arg2);
    }

    void qt_QButtonGroup_customEvent_void_QButtonGroup_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QButtonGroup*)arg0)->customEvent_pub_parent(arg1);
        else
            ((MuQt_QButtonGroup*)arg0)->customEvent_pub(arg1);
    }

    void qt_QButtonGroup_timerEvent_void_QButtonGroup_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QButtonGroup* arg0 = object<QButtonGroup>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QButtonGroup*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QButtonGroup*)arg0)->timerEvent_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QButtonGroup0, Pointer)
    {
        NODE_RETURN(
            qt_QButtonGroup_QButtonGroup_QButtonGroup_QButtonGroup_QObject(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addButton0, void)
    {
        qt_QButtonGroup_addButton_void_QButtonGroup_QAbstractButton_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_button0, Pointer)
    {
        NODE_RETURN(qt_QButtonGroup_button_QAbstractButton_QButtonGroup_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_checkedButton0, Pointer)
    {
        NODE_RETURN(qt_QButtonGroup_checkedButton_QAbstractButton_QButtonGroup(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_checkedId0, int)
    {
        NODE_RETURN(qt_QButtonGroup_checkedId_int_QButtonGroup(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_id0, int)
    {
        NODE_RETURN(qt_QButtonGroup_id_int_QButtonGroup_QAbstractButton(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_removeButton0, void)
    {
        qt_QButtonGroup_removeButton_void_QButtonGroup_QAbstractButton(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setId0, void)
    {
        qt_QButtonGroup_setId_void_QButtonGroup_QAbstractButton_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QButtonGroup_event_bool_QButtonGroup_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(
            qt_QButtonGroup_eventFilter_bool_QButtonGroup_QObject_QEvent(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_customEvent0, void)
    {
        qt_QButtonGroup_customEvent_void_QButtonGroup_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QButtonGroup_timerEvent_void_QButtonGroup_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    void QButtonGroupType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QButtonGroup_QButtonGroup_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QButtonGroup", _n_QButtonGroup0, None, Compiled,
                qt_QButtonGroup_QButtonGroup_QButtonGroup_QButtonGroup_QObject,
                Return, "qt.QButtonGroup", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "parent", "qt.QObject"), End),
            new Function(
                c, "addButton", _n_addButton0, None, Compiled,
                qt_QButtonGroup_addButton_void_QButtonGroup_QAbstractButton_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "button", "qt.QAbstractButton"),
                new Param(c, "id", "int", Value((int)-1)), End),
            new Function(
                c, "button", _n_button0, None, Compiled,
                qt_QButtonGroup_button_QAbstractButton_QButtonGroup_int, Return,
                "qt.QAbstractButton", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "id", "int"), End),
            // MISSING: buttons ("QList<QAbstractButton * >"; QButtonGroup this)
            new Function(
                c, "checkedButton", _n_checkedButton0, None, Compiled,
                qt_QButtonGroup_checkedButton_QAbstractButton_QButtonGroup,
                Return, "qt.QAbstractButton", Parameters,
                new Param(c, "this", "qt.QButtonGroup"), End),
            new Function(c, "checkedId", _n_checkedId0, None, Compiled,
                         qt_QButtonGroup_checkedId_int_QButtonGroup, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QButtonGroup"), End),
            // PROP: exclusive (bool; QButtonGroup this)
            new Function(c, "id", _n_id0, None, Compiled,
                         qt_QButtonGroup_id_int_QButtonGroup_QAbstractButton,
                         Return, "int", Parameters,
                         new Param(c, "this", "qt.QButtonGroup"),
                         new Param(c, "button", "qt.QAbstractButton"), End),
            new Function(
                c, "removeButton", _n_removeButton0, None, Compiled,
                qt_QButtonGroup_removeButton_void_QButtonGroup_QAbstractButton,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "button", "qt.QAbstractButton"), End),
            // PROP: setExclusive (void; QButtonGroup this, bool _p4)
            new Function(
                c, "setId", _n_setId0, None, Compiled,
                qt_QButtonGroup_setId_void_QButtonGroup_QAbstractButton_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "button", "qt.QAbstractButton"),
                new Param(c, "id", "int"), End),
            _func[0] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QButtonGroup_event_bool_QButtonGroup_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "e", "qt.QEvent"), End),
            _func[1] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QButtonGroup_eventFilter_bool_QButtonGroup_QObject_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "watched", "qt.QObject"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: metaObject ("const QMetaObject *"; QButtonGroup this)
            // MISSING: childEvent (void; QButtonGroup this, "QChildEvent *"
            // event) // protected MISSING: connectNotify (void; QButtonGroup
            // this, "const QMetaMethod &" signal) // protected
            _func[2] = new MemberFunction(
                c, "customEvent", _n_customEvent0, None, Compiled,
                qt_QButtonGroup_customEvent_void_QButtonGroup_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: disconnectNotify (void; QButtonGroup this, "const
            // QMetaMethod &" signal) // protected
            _func[3] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QButtonGroup_timerEvent_void_QButtonGroup_QTimerEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QButtonGroup"),
                new Param(c, "event", "qt.QTimerEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QButtonGroup::staticMetaObject, propExclusions);
    }

} // namespace Mu
