//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QColumnViewType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QAbstractItemModelType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QModelIndexType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QItemSelectionType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QItemSelectionModelType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QRectType.h>
#include <MuQt6/QAbstractItemViewType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QRegionType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QPointType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QColumnView::~MuQt_QColumnView()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QColumnView::MuQt_QColumnView(Pointer muobj, const CallEnvironment* ce,
                                       QWidget* parent)
        : QColumnView(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QColumnViewType>(
            c->internName("qt.QColumnView"));
    }

    QModelIndex MuQt_QColumnView::indexAt(const QPoint& point) const
    {
        if (!_env)
            return QColumnView::indexAt(point);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QPointType>(c, point, "qt.QPoint"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QColumnView::indexAt(point);
        }
    }

    void MuQt_QColumnView::scrollTo(const QModelIndex& index,
                                    QAbstractItemView::ScrollHint hint)
    {
        if (!_env)
        {
            QColumnView::scrollTo(index, hint);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(int(hint));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::scrollTo(index, hint);
        }
    }

    void MuQt_QColumnView::selectAll()
    {
        if (!_env)
        {
            QColumnView::selectAll();
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::selectAll();
        }
    }

    void MuQt_QColumnView::setModel(QAbstractItemModel* model)
    {
        if (!_env)
        {
            QColumnView::setModel(model);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QAbstractItemModelType>(
                c, model, "qt.QAbstractItemModel"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::setModel(model);
        }
    }

    void MuQt_QColumnView::setRootIndex(const QModelIndex& index)
    {
        if (!_env)
        {
            QColumnView::setRootIndex(index);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::setRootIndex(index);
        }
    }

    void
    MuQt_QColumnView::setSelectionModel(QItemSelectionModel* newSelectionModel)
    {
        if (!_env)
        {
            QColumnView::setSelectionModel(newSelectionModel);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QItemSelectionModelType>(
                c, newSelectionModel, "qt.QItemSelectionModel"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::setSelectionModel(newSelectionModel);
        }
    }

    QSize MuQt_QColumnView::sizeHint() const
    {
        if (!_env)
            return QColumnView::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QColumnView::sizeHint();
        }
    }

    QRect MuQt_QColumnView::visualRect(const QModelIndex& index) const
    {
        if (!_env)
            return QColumnView::visualRect(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QRectType>(rval._Pointer);
        }
        else
        {
            return QColumnView::visualRect(index);
        }
    }

    QAbstractItemView* MuQt_QColumnView::createColumn(const QModelIndex& index)
    {
        if (!_env)
            return QColumnView::createColumn(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return object<QAbstractItemView>(rval._Pointer);
        }
        else
        {
            return QColumnView::createColumn(index);
        }
    }

    void MuQt_QColumnView::currentChanged(const QModelIndex& current,
                                          const QModelIndex& previous)
    {
        if (!_env)
        {
            QColumnView::currentChanged(current, previous);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, current, "qt.QModelIndex"));
            args[2] = Value(
                makeqtype<QModelIndexType>(c, previous, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::currentChanged(current, previous);
        }
    }

    int MuQt_QColumnView::horizontalOffset() const
    {
        if (!_env)
            return QColumnView::horizontalOffset();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QColumnView::horizontalOffset();
        }
    }

    bool MuQt_QColumnView::isIndexHidden(const QModelIndex& index) const
    {
        if (!_env)
            return QColumnView::isIndexHidden(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::isIndexHidden(index);
        }
    }

    void MuQt_QColumnView::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QColumnView::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::resizeEvent(event);
        }
    }

    void MuQt_QColumnView::rowsInserted(const QModelIndex& parent, int start,
                                        int end)
    {
        if (!_env)
        {
            QColumnView::rowsInserted(parent, start, end);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, parent, "qt.QModelIndex"));
            args[2] = Value(start);
            args[3] = Value(end);
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::rowsInserted(parent, start, end);
        }
    }

    void MuQt_QColumnView::scrollContentsBy(int dx, int dy)
    {
        if (!_env)
        {
            QColumnView::scrollContentsBy(dx, dy);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(dx);
            args[2] = Value(dy);
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::scrollContentsBy(dx, dy);
        }
    }

    void
    MuQt_QColumnView::setSelection(const QRect& rect,
                                   QItemSelectionModel::SelectionFlags command)
    {
        if (!_env)
        {
            QColumnView::setSelection(rect, command);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QRectType>(c, rect, "qt.QRect"));
            args[2] = Value(int(command));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::setSelection(rect, command);
        }
    }

    int MuQt_QColumnView::verticalOffset() const
    {
        if (!_env)
            return QColumnView::verticalOffset();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QColumnView::verticalOffset();
        }
    }

    QRegion MuQt_QColumnView::visualRegionForSelection(
        const QItemSelection& selection) const
    {
        if (!_env)
            return QColumnView::visualRegionForSelection(selection);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QItemSelectionType>(c, selection,
                                                          "qt.QItemSelection"));
            Value rval = _env->call(F, args);
            return getqtype<QRegionType>(rval._Pointer);
        }
        else
        {
            return QColumnView::visualRegionForSelection(selection);
        }
    }

    void MuQt_QColumnView::keyboardSearch(const QString& search)
    {
        if (!_env)
        {
            QColumnView::keyboardSearch(search);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makestring(c, search));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::keyboardSearch(search);
        }
    }

    int MuQt_QColumnView::sizeHintForColumn(int column) const
    {
        if (!_env)
            return QColumnView::sizeHintForColumn(column);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QColumnView::sizeHintForColumn(column);
        }
    }

    int MuQt_QColumnView::sizeHintForRow(int row) const
    {
        if (!_env)
            return QColumnView::sizeHintForRow(row);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QColumnView::sizeHintForRow(row);
        }
    }

    QVariant
    MuQt_QColumnView::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QColumnView::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QColumnView::inputMethodQuery(query);
        }
    }

    bool MuQt_QColumnView::edit(const QModelIndex& index,
                                QAbstractItemView::EditTrigger trigger,
                                QEvent* event)
    {
        if (!_env)
            return QColumnView::edit(index, trigger, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(int(trigger));
            args[3] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::edit(index, trigger, event);
        }
    }

    QModelIndexList MuQt_QColumnView::selectedIndexes() const
    {
        if (!_env)
            return QColumnView::selectedIndexes();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return qmodelindexlist(rval._Pointer);
        }
        else
        {
            return QColumnView::selectedIndexes();
        }
    }

    QItemSelectionModel::SelectionFlags
    MuQt_QColumnView::selectionCommand(const QModelIndex& index,
                                       const QEvent* event) const
    {
        if (!_env)
            return QColumnView::selectionCommand(index, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (QItemSelectionModel::SelectionFlags)(rval._int);
        }
        else
        {
            return QColumnView::selectionCommand(index, event);
        }
    }

    void MuQt_QColumnView::startDrag(Qt::DropActions supportedActions)
    {
        if (!_env)
        {
            QColumnView::startDrag(supportedActions);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(supportedActions));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::startDrag(supportedActions);
        }
    }

    void MuQt_QColumnView::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QColumnView::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::dragEnterEvent(event);
        }
    }

    void MuQt_QColumnView::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QColumnView::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::dragLeaveEvent(event);
        }
    }

    void MuQt_QColumnView::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QColumnView::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::dragMoveEvent(event);
        }
    }

    void MuQt_QColumnView::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QColumnView::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::dropEvent(event);
        }
    }

    bool MuQt_QColumnView::event(QEvent* event_)
    {
        if (!_env)
            return QColumnView::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::event(event_);
        }
    }

    bool MuQt_QColumnView::eventFilter(QObject* object, QEvent* event)
    {
        if (!_env)
            return QColumnView::eventFilter(object, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QObjectType>(c, object, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::eventFilter(object, event);
        }
    }

    void MuQt_QColumnView::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QColumnView::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::focusInEvent(event);
        }
    }

    bool MuQt_QColumnView::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QColumnView::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[33];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::focusNextPrevChild(next);
        }
    }

    void MuQt_QColumnView::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QColumnView::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[34];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::focusOutEvent(event);
        }
    }

    void MuQt_QColumnView::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QColumnView::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[35];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::keyPressEvent(event);
        }
    }

    void MuQt_QColumnView::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QColumnView::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[36];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QColumnView::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QColumnView::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[37];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::mouseMoveEvent(event);
        }
    }

    void MuQt_QColumnView::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QColumnView::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[38];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::mousePressEvent(event);
        }
    }

    void MuQt_QColumnView::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QColumnView::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[39];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::mouseReleaseEvent(event);
        }
    }

    void MuQt_QColumnView::timerEvent(QTimerEvent* event)
    {
        if (!_env)
        {
            QColumnView::timerEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[40];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTimerEventType>(c, event, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QColumnView::timerEvent(event);
        }
    }

    bool MuQt_QColumnView::viewportEvent(QEvent* event)
    {
        if (!_env)
            return QColumnView::viewportEvent(event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[41];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QColumnView::viewportEvent(event);
        }
    }

    QSize MuQt_QColumnView::viewportSizeHint() const
    {
        if (!_env)
            return QColumnView::viewportSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[42];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QColumnView::viewportSizeHint();
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QColumnViewType::QColumnViewType(Context* c, const char* name, Class* super,
                                     Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QColumnViewType::~QColumnViewType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QColumnView_QColumnView_QObject(Thread& NODE_THREAD,
                                                   Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QColumnView* w = object<QColumnView>(widget))
        {
            QColumnViewType* type =
                c->findSymbolOfTypeByQualifiedName<QColumnViewType>(
                    c->internName("qt.QColumnView"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(
            QColumnView_QColumnView_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QColumnView_QColumnView_QColumnView_QColumnView_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QColumnView(param_this,
                                       NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer
    qt_QColumnView_previewWidget_QWidget_QColumnView(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return makeinstance<QWidgetType>(c, arg0->previewWidget(),
                                         "qt.QWidget");
    }

    void qt_QColumnView_setPreviewWidget_void_QColumnView_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QWidget* arg1 = object<QWidget>(param_widget);
        arg0->setPreviewWidget(arg1);
    }

    Pointer qt_QColumnView_indexAt_QModelIndex_QColumnView_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_point)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_point);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QColumnView::indexAt(arg1), "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(c, arg0->indexAt(arg1),
                                                "qt.QModelIndex");
    }

    void qt_QColumnView_scrollTo_void_QColumnView_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_hint)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        QAbstractItemView::ScrollHint arg2 =
            (QAbstractItemView::ScrollHint)(param_hint);
        if (isMuQtObject(arg0))
            arg0->QColumnView::scrollTo(arg1, arg2);
        else
            arg0->scrollTo(arg1, arg2);
    }

    void qt_QColumnView_selectAll_void_QColumnView(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        if (isMuQtObject(arg0))
            arg0->QColumnView::selectAll();
        else
            arg0->selectAll();
    }

    void qt_QColumnView_setModel_void_QColumnView_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_model)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QAbstractItemModel* arg1 = object<QAbstractItemModel>(param_model);
        if (isMuQtObject(arg0))
            arg0->QColumnView::setModel(arg1);
        else
            arg0->setModel(arg1);
    }

    void qt_QColumnView_setRootIndex_void_QColumnView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        if (isMuQtObject(arg0))
            arg0->QColumnView::setRootIndex(arg1);
        else
            arg0->setRootIndex(arg1);
    }

    void qt_QColumnView_setSelectionModel_void_QColumnView_QItemSelectionModel(
        Mu::Thread& NODE_THREAD, Pointer param_this,
        Pointer param_newSelectionModel)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QItemSelectionModel* arg1 =
            object<QItemSelectionModel>(param_newSelectionModel);
        if (isMuQtObject(arg0))
            arg0->QColumnView::setSelectionModel(arg1);
        else
            arg0->setSelectionModel(arg1);
    }

    Pointer qt_QColumnView_sizeHint_QSize_QColumnView(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QColumnView::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    Pointer qt_QColumnView_visualRect_QRect_QColumnView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QRectType>(
                         c, arg0->QColumnView::visualRect(arg1), "qt.QRect")
                   : makeqtype<QRectType>(c, arg0->visualRect(arg1),
                                          "qt.QRect");
    }

    Pointer
    qt_QColumnView_createColumn_QAbstractItemView_QColumnView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeinstance<QAbstractItemViewType>(
                         c,
                         ((MuQt_QColumnView*)arg0)
                             ->createColumn_pub_parent(arg1),
                         "qt.QAbstractItemView")
                   : makeinstance<QAbstractItemViewType>(
                         c, ((MuQt_QColumnView*)arg0)->createColumn_pub(arg1),
                         "qt.QAbstractItemView");
    }

    void qt_QColumnView_initializeColumn_void_QColumnView_QAbstractItemView(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QAbstractItemView* arg1 = object<QAbstractItemView>(param_column);
        ((MuQt_QColumnView*)arg0)->initializeColumn_pub(arg1);
    }

    void qt_QColumnView_currentChanged_void_QColumnView_QModelIndex_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_current,
        Pointer param_previous)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_current);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_previous);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->currentChanged_pub_parent(arg1, arg2);
        else
            ((MuQt_QColumnView*)arg0)->currentChanged_pub(arg1, arg2);
    }

    int qt_QColumnView_horizontalOffset_int_QColumnView(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)->horizontalOffset_pub_parent()
                   : ((MuQt_QColumnView*)arg0)->horizontalOffset_pub();
    }

    bool qt_QColumnView_isIndexHidden_bool_QColumnView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)->isIndexHidden_pub_parent(arg1)
                   : ((MuQt_QColumnView*)arg0)->isIndexHidden_pub(arg1);
    }

    void qt_QColumnView_resizeEvent_void_QColumnView_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QColumnView_rowsInserted_void_QColumnView_QModelIndex_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent,
        int param_start, int param_end)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_parent);
        int arg2 = (int)(param_start);
        int arg3 = (int)(param_end);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)
                ->rowsInserted_pub_parent(arg1, arg2, arg3);
        else
            ((MuQt_QColumnView*)arg0)->rowsInserted_pub(arg1, arg2, arg3);
    }

    void qt_QColumnView_scrollContentsBy_void_QColumnView_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_dx, int param_dy)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        int arg1 = (int)(param_dx);
        int arg2 = (int)(param_dy);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->scrollContentsBy_pub_parent(arg1, arg2);
        else
            ((MuQt_QColumnView*)arg0)->scrollContentsBy_pub(arg1, arg2);
    }

    void qt_QColumnView_setSelection_void_QColumnView_QRect_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_rect,
        int param_command)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QRect arg1 = getqtype<QRectType>(param_rect);
        QItemSelectionModel::SelectionFlags arg2 =
            (QItemSelectionModel::SelectionFlags)(param_command);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->setSelection_pub_parent(arg1, arg2);
        else
            ((MuQt_QColumnView*)arg0)->setSelection_pub(arg1, arg2);
    }

    int qt_QColumnView_verticalOffset_int_QColumnView(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)->verticalOffset_pub_parent()
                   : ((MuQt_QColumnView*)arg0)->verticalOffset_pub();
    }

    Pointer
    qt_QColumnView_visualRegionForSelection_QRegion_QColumnView_QItemSelection(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_selection)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QItemSelection arg1 =
            getqtype<QItemSelectionType>(param_selection);
        return isMuQtObject(arg0)
                   ? makeqtype<QRegionType>(
                         c,
                         ((MuQt_QColumnView*)arg0)
                             ->visualRegionForSelection_pub_parent(arg1),
                         "qt.QRegion")
                   : makeqtype<QRegionType>(
                         c,
                         ((MuQt_QColumnView*)arg0)
                             ->visualRegionForSelection_pub(arg1),
                         "qt.QRegion");
    }

    void qt_QColumnView_keyboardSearch_void_QColumnView_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_search)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QString arg1 = qstring(param_search);
        if (isMuQtObject(arg0))
            arg0->QColumnView::keyboardSearch(arg1);
        else
            arg0->keyboardSearch(arg1);
    }

    int qt_QColumnView_sizeHintForColumn_int_QColumnView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        int arg1 = (int)(param_column);
        return isMuQtObject(arg0) ? arg0->QColumnView::sizeHintForColumn(arg1)
                                  : arg0->sizeHintForColumn(arg1);
    }

    int qt_QColumnView_sizeHintForRow_int_QColumnView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        int arg1 = (int)(param_row);
        return isMuQtObject(arg0) ? arg0->QColumnView::sizeHintForRow(arg1)
                                  : arg0->sizeHintForRow(arg1);
    }

    Pointer qt_QColumnView_inputMethodQuery_QVariant_QColumnView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QColumnView::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    bool qt_QColumnView_edit_bool_QColumnView_QModelIndex_int_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_trigger, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        QAbstractItemView::EditTrigger arg2 =
            (QAbstractItemView::EditTrigger)(param_trigger);
        QEvent* arg3 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)
                         ->edit_pub_parent(arg1, arg2, arg3)
                   : ((MuQt_QColumnView*)arg0)->edit_pub(arg1, arg2, arg3);
    }

    Pointer qt_QColumnView_selectedIndexes_qt__QModelIndexBSB_ESB__QColumnView(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return isMuQtObject(arg0)
                   ? makeqmodelindexlist(c, ((MuQt_QColumnView*)arg0)
                                                ->selectedIndexes_pub_parent())
                   : makeqmodelindexlist(
                         c, ((MuQt_QColumnView*)arg0)->selectedIndexes_pub());
    }

    int qt_QColumnView_selectionCommand_int_QColumnView_QModelIndex_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        const QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? int(((MuQt_QColumnView*)arg0)
                             ->selectionCommand_pub_parent(arg1, arg2))
                   : int(((MuQt_QColumnView*)arg0)
                             ->selectionCommand_pub(arg1, arg2));
    }

    void qt_QColumnView_startDrag_void_QColumnView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_supportedActions)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        Qt::DropActions arg1 = (Qt::DropActions)(param_supportedActions);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->startDrag_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->startDrag_pub(arg1);
    }

    void qt_QColumnView_dragEnterEvent_void_QColumnView_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QColumnView_dragLeaveEvent_void_QColumnView_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QColumnView_dragMoveEvent_void_QColumnView_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QColumnView_dropEvent_void_QColumnView_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->dropEvent_pub(arg1);
    }

    bool qt_QColumnView_event_bool_QColumnView_QEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QColumnView*)arg0)->event_pub(arg1);
    }

    bool qt_QColumnView_eventFilter_bool_QColumnView_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_object,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QObject* arg1 = object<QObject>(param_object);
        QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)
                         ->eventFilter_pub_parent(arg1, arg2)
                   : ((MuQt_QColumnView*)arg0)->eventFilter_pub(arg1, arg2);
    }

    void qt_QColumnView_focusInEvent_void_QColumnView_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QColumnView_focusNextPrevChild_bool_QColumnView_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QColumnView*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QColumnView_focusOutEvent_void_QColumnView_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QColumnView_keyPressEvent_void_QColumnView_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QColumnView_mouseDoubleClickEvent_void_QColumnView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QColumnView_mouseMoveEvent_void_QColumnView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QColumnView_mousePressEvent_void_QColumnView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QColumnView_mouseReleaseEvent_void_QColumnView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QColumnView_timerEvent_void_QColumnView_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QColumnView*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QColumnView*)arg0)->timerEvent_pub(arg1);
    }

    bool qt_QColumnView_viewportEvent_bool_QColumnView_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QColumnView*)arg0)->viewportEvent_pub_parent(arg1)
                   : ((MuQt_QColumnView*)arg0)->viewportEvent_pub(arg1);
    }

    Pointer
    qt_QColumnView_viewportSizeHint_QSize_QColumnView(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QColumnView* arg0 = object<QColumnView>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c,
                                          ((MuQt_QColumnView*)arg0)
                                              ->viewportSizeHint_pub_parent(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(
                         c, ((MuQt_QColumnView*)arg0)->viewportSizeHint_pub(),
                         "qt.QSize");
    }

    static NODE_IMPLEMENTATION(_n_QColumnView0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_QColumnView_QColumnView_QColumnView_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_previewWidget0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_previewWidget_QWidget_QColumnView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setPreviewWidget0, void)
    {
        qt_QColumnView_setPreviewWidget_void_QColumnView_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_indexAt0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_indexAt_QModelIndex_QColumnView_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_scrollTo0, void)
    {
        qt_QColumnView_scrollTo_void_QColumnView_QModelIndex_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_selectAll0, void)
    {
        qt_QColumnView_selectAll_void_QColumnView(NODE_THREAD,
                                                  NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setModel0, void)
    {
        qt_QColumnView_setModel_void_QColumnView_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setRootIndex0, void)
    {
        qt_QColumnView_setRootIndex_void_QColumnView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setSelectionModel0, void)
    {
        qt_QColumnView_setSelectionModel_void_QColumnView_QItemSelectionModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_sizeHint_QSize_QColumnView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_visualRect0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_visualRect_QRect_QColumnView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_createColumn0, Pointer)
    {
        NODE_RETURN(
            qt_QColumnView_createColumn_QAbstractItemView_QColumnView_QModelIndex(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_initializeColumn0, void)
    {
        qt_QColumnView_initializeColumn_void_QColumnView_QAbstractItemView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_currentChanged0, void)
    {
        qt_QColumnView_currentChanged_void_QColumnView_QModelIndex_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_horizontalOffset0, int)
    {
        NODE_RETURN(qt_QColumnView_horizontalOffset_int_QColumnView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isIndexHidden0, bool)
    {
        NODE_RETURN(qt_QColumnView_isIndexHidden_bool_QColumnView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QColumnView_resizeEvent_void_QColumnView_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_rowsInserted0, void)
    {
        qt_QColumnView_rowsInserted_void_QColumnView_QModelIndex_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_scrollContentsBy0, void)
    {
        qt_QColumnView_scrollContentsBy_void_QColumnView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_setSelection0, void)
    {
        qt_QColumnView_setSelection_void_QColumnView_QRect_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_verticalOffset0, int)
    {
        NODE_RETURN(qt_QColumnView_verticalOffset_int_QColumnView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_visualRegionForSelection0, Pointer)
    {
        NODE_RETURN(
            qt_QColumnView_visualRegionForSelection_QRegion_QColumnView_QItemSelection(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_keyboardSearch0, void)
    {
        qt_QColumnView_keyboardSearch_void_QColumnView_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_sizeHintForColumn0, int)
    {
        NODE_RETURN(qt_QColumnView_sizeHintForColumn_int_QColumnView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHintForRow0, int)
    {
        NODE_RETURN(qt_QColumnView_sizeHintForRow_int_QColumnView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_inputMethodQuery_QVariant_QColumnView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_edit0, bool)
    {
        NODE_RETURN(qt_QColumnView_edit_bool_QColumnView_QModelIndex_int_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_selectedIndexes0, Pointer)
    {
        NODE_RETURN(
            qt_QColumnView_selectedIndexes_qt__QModelIndexBSB_ESB__QColumnView(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_selectionCommand0, int)
    {
        NODE_RETURN(
            qt_QColumnView_selectionCommand_int_QColumnView_QModelIndex_QEvent(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_startDrag0, void)
    {
        qt_QColumnView_startDrag_void_QColumnView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QColumnView_dragEnterEvent_void_QColumnView_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QColumnView_dragLeaveEvent_void_QColumnView_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QColumnView_dragMoveEvent_void_QColumnView_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QColumnView_dropEvent_void_QColumnView_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QColumnView_event_bool_QColumnView_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(qt_QColumnView_eventFilter_bool_QColumnView_QObject_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QColumnView_focusInEvent_void_QColumnView_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QColumnView_focusNextPrevChild_bool_QColumnView_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QColumnView_focusOutEvent_void_QColumnView_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QColumnView_keyPressEvent_void_QColumnView_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QColumnView_mouseDoubleClickEvent_void_QColumnView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QColumnView_mouseMoveEvent_void_QColumnView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QColumnView_mousePressEvent_void_QColumnView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QColumnView_mouseReleaseEvent_void_QColumnView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QColumnView_timerEvent_void_QColumnView_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_viewportEvent0, bool)
    {
        NODE_RETURN(qt_QColumnView_viewportEvent_bool_QColumnView_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_viewportSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QColumnView_viewportSizeHint_QSize_QColumnView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    void QColumnViewType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QColumnView_QColumnView_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QColumnView", _n_QColumnView0, None, Compiled,
                qt_QColumnView_QColumnView_QColumnView_QColumnView_QWidget,
                Return, "qt.QColumnView", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "parent", "qt.QWidget"), End),
            // MISSING: columnWidths ("QList<int>"; QColumnView this)
            new Function(c, "previewWidget", _n_previewWidget0, None, Compiled,
                         qt_QColumnView_previewWidget_QWidget_QColumnView,
                         Return, "qt.QWidget", Parameters,
                         new Param(c, "this", "qt.QColumnView"), End),
            // PROP: resizeGripsVisible (bool; QColumnView this)
            // MISSING: setColumnWidths (void; QColumnView this, "const
            // QList<int> &" list)
            new Function(
                c, "setPreviewWidget", _n_setPreviewWidget0, None, Compiled,
                qt_QColumnView_setPreviewWidget_void_QColumnView_QWidget,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "widget", "qt.QWidget"), End),
            // PROP: setResizeGripsVisible (void; QColumnView this, bool
            // visible)
            _func[0] = new MemberFunction(
                c, "indexAt", _n_indexAt0, None, Compiled,
                qt_QColumnView_indexAt_QModelIndex_QColumnView_QPoint, Return,
                "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "point", "qt.QPoint"), End),
            _func[1] = new MemberFunction(
                c, "scrollTo", _n_scrollTo0, None, Compiled,
                qt_QColumnView_scrollTo_void_QColumnView_QModelIndex_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "hint", "int",
                          Value((int)QAbstractItemView::EnsureVisible)),
                End),
            _func[2] = new MemberFunction(
                c, "selectAll", _n_selectAll0, None, Compiled,
                qt_QColumnView_selectAll_void_QColumnView, Return, "void",
                Parameters, new Param(c, "this", "qt.QColumnView"), End),
            _func[3] = new MemberFunction(
                c, "setModel", _n_setModel0, None, Compiled,
                qt_QColumnView_setModel_void_QColumnView_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "model", "qt.QAbstractItemModel"), End),
            _func[4] = new MemberFunction(
                c, "setRootIndex", _n_setRootIndex0, None, Compiled,
                qt_QColumnView_setRootIndex_void_QColumnView_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[5] = new MemberFunction(
                c, "setSelectionModel", _n_setSelectionModel0, None, Compiled,
                qt_QColumnView_setSelectionModel_void_QColumnView_QItemSelectionModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "newSelectionModel", "qt.QItemSelectionModel"),
                End),
            _func[6] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QColumnView_sizeHint_QSize_QColumnView, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QColumnView"), End),
            _func[7] = new MemberFunction(
                c, "visualRect", _n_visualRect0, None, Compiled,
                qt_QColumnView_visualRect_QRect_QColumnView_QModelIndex, Return,
                "qt.QRect", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[8] = new MemberFunction(
                c, "createColumn", _n_createColumn0, None, Compiled,
                qt_QColumnView_createColumn_QAbstractItemView_QColumnView_QModelIndex,
                Return, "qt.QAbstractItemView", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            new Function(
                c, "initializeColumn", _n_initializeColumn0, None, Compiled,
                qt_QColumnView_initializeColumn_void_QColumnView_QAbstractItemView,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "column", "qt.QAbstractItemView"), End),
            _func[9] = new MemberFunction(
                c, "currentChanged", _n_currentChanged0, None, Compiled,
                qt_QColumnView_currentChanged_void_QColumnView_QModelIndex_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "current", "qt.QModelIndex"),
                new Param(c, "previous", "qt.QModelIndex"), End),
            _func[10] = new MemberFunction(
                c, "horizontalOffset", _n_horizontalOffset0, None, Compiled,
                qt_QColumnView_horizontalOffset_int_QColumnView, Return, "int",
                Parameters, new Param(c, "this", "qt.QColumnView"), End),
            _func[11] = new MemberFunction(
                c, "isIndexHidden", _n_isIndexHidden0, None, Compiled,
                qt_QColumnView_isIndexHidden_bool_QColumnView_QModelIndex,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[12] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QColumnView_resizeEvent_void_QColumnView_QResizeEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[13] = new MemberFunction(
                c, "rowsInserted", _n_rowsInserted0, None, Compiled,
                qt_QColumnView_rowsInserted_void_QColumnView_QModelIndex_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "parent", "qt.QModelIndex"),
                new Param(c, "start", "int"), new Param(c, "end", "int"), End),
            _func[14] = new MemberFunction(
                c, "scrollContentsBy", _n_scrollContentsBy0, None, Compiled,
                qt_QColumnView_scrollContentsBy_void_QColumnView_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "dx", "int"), new Param(c, "dy", "int"), End),
            _func[15] = new MemberFunction(
                c, "setSelection", _n_setSelection0, None, Compiled,
                qt_QColumnView_setSelection_void_QColumnView_QRect_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "rect", "qt.QRect"),
                new Param(c, "command", "int"), End),
            _func[16] = new MemberFunction(
                c, "verticalOffset", _n_verticalOffset0, None, Compiled,
                qt_QColumnView_verticalOffset_int_QColumnView, Return, "int",
                Parameters, new Param(c, "this", "qt.QColumnView"), End),
            _func[17] = new MemberFunction(
                c, "visualRegionForSelection", _n_visualRegionForSelection0,
                None, Compiled,
                qt_QColumnView_visualRegionForSelection_QRegion_QColumnView_QItemSelection,
                Return, "qt.QRegion", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "selection", "qt.QItemSelection"), End),
            // MISSING: itemDelegateForIndex ("QAbstractItemDelegate *";
            // QColumnView this, QModelIndex index)
            _func[18] = new MemberFunction(
                c, "keyboardSearch", _n_keyboardSearch0, None, Compiled,
                qt_QColumnView_keyboardSearch_void_QColumnView_string, Return,
                "void", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "search", "string"), End),
            _func[19] = new MemberFunction(
                c, "sizeHintForColumn", _n_sizeHintForColumn0, None, Compiled,
                qt_QColumnView_sizeHintForColumn_int_QColumnView_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "column", "int"), End),
            _func[20] = new MemberFunction(
                c, "sizeHintForRow", _n_sizeHintForRow0, None, Compiled,
                qt_QColumnView_sizeHintForRow_int_QColumnView_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "row", "int"), End),
            _func[21] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QColumnView_inputMethodQuery_QVariant_QColumnView_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "query", "int"), End),
            _func[22] = new MemberFunction(
                c, "edit", _n_edit0, None, Compiled,
                qt_QColumnView_edit_bool_QColumnView_QModelIndex_int_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "trigger", "int"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: initViewItemOption (void; QColumnView this,
            // "QStyleOptionViewItem *" option) // protected
            _func[23] = new MemberFunction(
                c, "selectedIndexes", _n_selectedIndexes0, None, Compiled,
                qt_QColumnView_selectedIndexes_qt__QModelIndexBSB_ESB__QColumnView,
                Return, "qt.QModelIndex[]", Parameters,
                new Param(c, "this", "qt.QColumnView"), End),
            _func[24] = new MemberFunction(
                c, "selectionCommand", _n_selectionCommand0, None, Compiled,
                qt_QColumnView_selectionCommand_int_QColumnView_QModelIndex_QEvent,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[25] = new MemberFunction(
                c, "startDrag", _n_startDrag0, None, Compiled,
                qt_QColumnView_startDrag_void_QColumnView_int, Return, "void",
                Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "supportedActions", "int"), End),
            _func[26] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QColumnView_dragEnterEvent_void_QColumnView_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[27] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QColumnView_dragLeaveEvent_void_QColumnView_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[28] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QColumnView_dragMoveEvent_void_QColumnView_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[29] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QColumnView_dropEvent_void_QColumnView_QDropEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QDropEvent"), End),
            _func[30] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QColumnView_event_bool_QColumnView_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event_", "qt.QEvent"), End),
            _func[31] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QColumnView_eventFilter_bool_QColumnView_QObject_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "object", "qt.QObject"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[32] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QColumnView_focusInEvent_void_QColumnView_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[33] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QColumnView_focusNextPrevChild_bool_QColumnView_bool, Return,
                "bool", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "next", "bool"), End),
            _func[34] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QColumnView_focusOutEvent_void_QColumnView_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            // MISSING: inputMethodEvent (void; QColumnView this,
            // "QInputMethodEvent *" event) // protected
            _func[35] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QColumnView_keyPressEvent_void_QColumnView_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[36] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QColumnView_mouseDoubleClickEvent_void_QColumnView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[37] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QColumnView_mouseMoveEvent_void_QColumnView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[38] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QColumnView_mousePressEvent_void_QColumnView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[39] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QColumnView_mouseReleaseEvent_void_QColumnView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[40] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QColumnView_timerEvent_void_QColumnView_QTimerEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QTimerEvent"), End),
            _func[41] = new MemberFunction(
                c, "viewportEvent", _n_viewportEvent0, None, Compiled,
                qt_QColumnView_viewportEvent_bool_QColumnView_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QColumnView"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[42] = new MemberFunction(
                c, "viewportSizeHint", _n_viewportSizeHint0, None, Compiled,
                qt_QColumnView_viewportSizeHint_QSize_QColumnView, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QColumnView"),
                End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QColumnView::staticMetaObject, propExclusions);
    }

} // namespace Mu
