//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QFileOpenEventType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/Thread.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QUrlType.h>

namespace Mu
{
    using namespace std;

    QFileOpenEventType::QFileOpenEventType(Context* c, const char* name,
                                           Class* super)
        : Class(c, name, super)
    {
    }

    QFileOpenEventType::~QFileOpenEventType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    Pointer
    qt_QFileOpenEvent_file_string_QFileOpenEvent(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QFileOpenEvent* arg0 = getqpointer<QFileOpenEventType>(param_this);
        return makestring(c, arg0->file());
    }

    Pointer qt_QFileOpenEvent_url_QUrl_QFileOpenEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QFileOpenEvent* arg0 = getqpointer<QFileOpenEventType>(param_this);
        return makeqtype<QUrlType>(c, arg0->url(), "qt.QUrl");
    }

    static NODE_IMPLEMENTATION(_n_file0, Pointer)
    {
        NODE_RETURN(qt_QFileOpenEvent_file_string_QFileOpenEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_url0, Pointer)
    {
        NODE_RETURN(qt_QFileOpenEvent_url_QUrl_QFileOpenEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    void QFileOpenEventType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new MemberVariable(c, "native", "qt.NativeObject"),

                   EndArguments);

        addSymbols(EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "file", _n_file0, None, Compiled,
                         qt_QFileOpenEvent_file_string_QFileOpenEvent, Return,
                         "string", Parameters,
                         new Param(c, "this", "qt.QFileOpenEvent"), End),
            new Function(c, "url", _n_url0, None, Compiled,
                         qt_QFileOpenEvent_url_QUrl_QFileOpenEvent, Return,
                         "qt.QUrl", Parameters,
                         new Param(c, "this", "qt.QFileOpenEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);
    }

} // namespace Mu
