//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QProgressBarType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QHideEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QProgressBar::~MuQt_QProgressBar()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QProgressBar::MuQt_QProgressBar(Pointer muobj,
                                         const CallEnvironment* ce,
                                         QWidget* parent)
        : QProgressBar(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QProgressBarType>(
            c->internName("qt.QProgressBar"));
    }

    QString MuQt_QProgressBar::text() const
    {
        if (!_env)
            return QProgressBar::text();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return qstring(rval._Pointer);
        }
        else
        {
            return QProgressBar::text();
        }
    }

    QSize MuQt_QProgressBar::minimumSizeHint() const
    {
        if (!_env)
            return QProgressBar::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QProgressBar::minimumSizeHint();
        }
    }

    QSize MuQt_QProgressBar::sizeHint() const
    {
        if (!_env)
            return QProgressBar::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QProgressBar::sizeHint();
        }
    }

    bool MuQt_QProgressBar::event(QEvent* e)
    {
        if (!_env)
            return QProgressBar::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QProgressBar::event(e);
        }
    }

    void MuQt_QProgressBar::paintEvent(QPaintEvent* _p14)
    {
        if (!_env)
        {
            QProgressBar::paintEvent(_p14);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QPaintEventType>(c, _p14, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::paintEvent(_p14);
        }
    }

    bool MuQt_QProgressBar::hasHeightForWidth() const
    {
        if (!_env)
            return QProgressBar::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QProgressBar::hasHeightForWidth();
        }
    }

    int MuQt_QProgressBar::heightForWidth(int w) const
    {
        if (!_env)
            return QProgressBar::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QProgressBar::heightForWidth(w);
        }
    }

    QVariant
    MuQt_QProgressBar::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QProgressBar::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QProgressBar::inputMethodQuery(query);
        }
    }

    void MuQt_QProgressBar::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QProgressBar::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::changeEvent(event);
        }
    }

    void MuQt_QProgressBar::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QProgressBar::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::closeEvent(event);
        }
    }

    void MuQt_QProgressBar::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QProgressBar::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::contextMenuEvent(event);
        }
    }

    void MuQt_QProgressBar::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QProgressBar::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::dragEnterEvent(event);
        }
    }

    void MuQt_QProgressBar::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QProgressBar::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::dragLeaveEvent(event);
        }
    }

    void MuQt_QProgressBar::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QProgressBar::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::dragMoveEvent(event);
        }
    }

    void MuQt_QProgressBar::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QProgressBar::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::dropEvent(event);
        }
    }

    void MuQt_QProgressBar::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QProgressBar::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::focusInEvent(event);
        }
    }

    bool MuQt_QProgressBar::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QProgressBar::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QProgressBar::focusNextPrevChild(next);
        }
    }

    void MuQt_QProgressBar::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QProgressBar::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::focusOutEvent(event);
        }
    }

    void MuQt_QProgressBar::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QProgressBar::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::hideEvent(event);
        }
    }

    void MuQt_QProgressBar::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QProgressBar::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::keyPressEvent(event);
        }
    }

    void MuQt_QProgressBar::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QProgressBar::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::keyReleaseEvent(event);
        }
    }

    void MuQt_QProgressBar::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QProgressBar::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::leaveEvent(event);
        }
    }

    void MuQt_QProgressBar::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QProgressBar::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QProgressBar::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QProgressBar::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::mouseMoveEvent(event);
        }
    }

    void MuQt_QProgressBar::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QProgressBar::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::mousePressEvent(event);
        }
    }

    void MuQt_QProgressBar::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QProgressBar::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::mouseReleaseEvent(event);
        }
    }

    void MuQt_QProgressBar::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QProgressBar::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::moveEvent(event);
        }
    }

    void MuQt_QProgressBar::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QProgressBar::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::resizeEvent(event);
        }
    }

    void MuQt_QProgressBar::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QProgressBar::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::showEvent(event);
        }
    }

    void MuQt_QProgressBar::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QProgressBar::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::tabletEvent(event);
        }
    }

    void MuQt_QProgressBar::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QProgressBar::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QProgressBar::wheelEvent(event);
        }
    }

    int MuQt_QProgressBar::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QProgressBar::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QProgressBar::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QProgressBarType::QProgressBarType(Context* c, const char* name,
                                       Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QProgressBarType::~QProgressBarType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QProgressBar_QProgressBar_QObject(Thread& NODE_THREAD,
                                                     Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QProgressBar* w = object<QProgressBar>(widget))
        {
            QProgressBarType* type =
                c->findSymbolOfTypeByQualifiedName<QProgressBarType>(
                    c->internName("qt.QProgressBar"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QProgressBar_QProgressBar_QObject(NODE_THREAD,
                                                      NODE_ARG(0, Pointer)));
    }

    Pointer qt_QProgressBar_QProgressBar_QProgressBar_QProgressBar_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QProgressBar(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer qt_QProgressBar_text_string_QProgressBar(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        return isMuQtObject(arg0) ? makestring(c, arg0->QProgressBar::text())
                                  : makestring(c, arg0->text());
    }

    Pointer
    qt_QProgressBar_minimumSizeHint_QSize_QProgressBar(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QProgressBar::minimumSizeHint(), "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer qt_QProgressBar_sizeHint_QSize_QProgressBar(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QProgressBar::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    bool qt_QProgressBar_event_bool_QProgressBar_QEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0)
                   ? ((MuQt_QProgressBar*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QProgressBar*)arg0)->event_pub(arg1);
    }

    void qt_QProgressBar_paintEvent_void_QProgressBar_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param__p14)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param__p14);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->paintEvent_pub(arg1);
    }

    bool
    qt_QProgressBar_hasHeightForWidth_bool_QProgressBar(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        return isMuQtObject(arg0) ? arg0->QProgressBar::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QProgressBar_heightForWidth_int_QProgressBar_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QProgressBar::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QProgressBar_inputMethodQuery_QVariant_QProgressBar_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QProgressBar::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    void qt_QProgressBar_changeEvent_void_QProgressBar_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QProgressBar_closeEvent_void_QProgressBar_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->closeEvent_pub(arg1);
    }

    void qt_QProgressBar_contextMenuEvent_void_QProgressBar_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QProgressBar_dragEnterEvent_void_QProgressBar_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QProgressBar_dragLeaveEvent_void_QProgressBar_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QProgressBar_dragMoveEvent_void_QProgressBar_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QProgressBar_dropEvent_void_QProgressBar_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QProgressBar_focusInEvent_void_QProgressBar_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QProgressBar_focusNextPrevChild_bool_QProgressBar_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QProgressBar*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QProgressBar*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QProgressBar_focusOutEvent_void_QProgressBar_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QProgressBar_hideEvent_void_QProgressBar_QHideEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QProgressBar_keyPressEvent_void_QProgressBar_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QProgressBar_keyReleaseEvent_void_QProgressBar_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QProgressBar_leaveEvent_void_QProgressBar_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->leaveEvent_pub(arg1);
    }

    void qt_QProgressBar_mouseDoubleClickEvent_void_QProgressBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QProgressBar_mouseMoveEvent_void_QProgressBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QProgressBar_mousePressEvent_void_QProgressBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QProgressBar_mouseReleaseEvent_void_QProgressBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QProgressBar_moveEvent_void_QProgressBar_QMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QProgressBar_resizeEvent_void_QProgressBar_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QProgressBar_showEvent_void_QProgressBar_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->showEvent_pub(arg1);
    }

    void qt_QProgressBar_tabletEvent_void_QProgressBar_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->tabletEvent_pub(arg1);
    }

    void qt_QProgressBar_wheelEvent_void_QProgressBar_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QProgressBar*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QProgressBar*)arg0)->wheelEvent_pub(arg1);
    }

    int qt_QProgressBar_metric_int_QProgressBar_int(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QProgressBar* arg0 = object<QProgressBar>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QProgressBar*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QProgressBar*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QProgressBar0, Pointer)
    {
        NODE_RETURN(
            qt_QProgressBar_QProgressBar_QProgressBar_QProgressBar_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_text0, Pointer)
    {
        NODE_RETURN(qt_QProgressBar_text_string_QProgressBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QProgressBar_minimumSizeHint_QSize_QProgressBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QProgressBar_sizeHint_QSize_QProgressBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QProgressBar_event_bool_QProgressBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QProgressBar_paintEvent_void_QProgressBar_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QProgressBar_hasHeightForWidth_bool_QProgressBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QProgressBar_heightForWidth_int_QProgressBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QProgressBar_inputMethodQuery_QVariant_QProgressBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QProgressBar_changeEvent_void_QProgressBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QProgressBar_closeEvent_void_QProgressBar_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QProgressBar_contextMenuEvent_void_QProgressBar_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QProgressBar_dragEnterEvent_void_QProgressBar_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QProgressBar_dragLeaveEvent_void_QProgressBar_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QProgressBar_dragMoveEvent_void_QProgressBar_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QProgressBar_dropEvent_void_QProgressBar_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QProgressBar_focusInEvent_void_QProgressBar_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QProgressBar_focusNextPrevChild_bool_QProgressBar_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QProgressBar_focusOutEvent_void_QProgressBar_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QProgressBar_hideEvent_void_QProgressBar_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QProgressBar_keyPressEvent_void_QProgressBar_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QProgressBar_keyReleaseEvent_void_QProgressBar_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QProgressBar_leaveEvent_void_QProgressBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QProgressBar_mouseDoubleClickEvent_void_QProgressBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QProgressBar_mouseMoveEvent_void_QProgressBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QProgressBar_mousePressEvent_void_QProgressBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QProgressBar_mouseReleaseEvent_void_QProgressBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QProgressBar_moveEvent_void_QProgressBar_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QProgressBar_resizeEvent_void_QProgressBar_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QProgressBar_showEvent_void_QProgressBar_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QProgressBar_tabletEvent_void_QProgressBar_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QProgressBar_wheelEvent_void_QProgressBar_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QProgressBar_metric_int_QProgressBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QProgressBarType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QProgressBar_QProgressBar_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QProgressBar", _n_QProgressBar0, None, Compiled,
                qt_QProgressBar_QProgressBar_QProgressBar_QProgressBar_QWidget,
                Return, "qt.QProgressBar", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "parent", "qt.QWidget"), End),
            // PROP: alignment (flags Qt::Alignment; QProgressBar this)
            // PROP: format (string; QProgressBar this)
            // PROP: invertedAppearance (bool; QProgressBar this)
            // PROP: isTextVisible (bool; QProgressBar this)
            // PROP: maximum (int; QProgressBar this)
            // PROP: minimum (int; QProgressBar this)
            // PROP: orientation (flags Qt::Orientation; QProgressBar this)
            // PROP: resetFormat (void; QProgressBar this)
            // PROP: setAlignment (void; QProgressBar this, flags Qt::Alignment
            // alignment) PROP: setFormat (void; QProgressBar this, string
            // format) PROP: setInvertedAppearance (void; QProgressBar this,
            // bool invert) PROP: setTextDirection (void; QProgressBar this,
            // flags QProgressBar::Direction textDirection) PROP: setTextVisible
            // (void; QProgressBar this, bool visible)
            _func[0] = new MemberFunction(
                c, "text", _n_text0, None, Compiled,
                qt_QProgressBar_text_string_QProgressBar, Return, "string",
                Parameters, new Param(c, "this", "qt.QProgressBar"), End),
            // PROP: textDirection (flags QProgressBar::Direction; QProgressBar
            // this) PROP: value (int; QProgressBar this)
            _func[1] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QProgressBar_minimumSizeHint_QSize_QProgressBar, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QProgressBar"),
                End),
            _func[2] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QProgressBar_sizeHint_QSize_QProgressBar, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QProgressBar"), End),
            // MISSING: initStyleOption (void; QProgressBar this,
            // "QStyleOptionProgressBar *" option) // protected
            _func[3] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QProgressBar_event_bool_QProgressBar_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "e", "qt.QEvent"), End),
            _func[4] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QProgressBar_paintEvent_void_QProgressBar_QPaintEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "_p14", "qt.QPaintEvent"), End),
            _func[5] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QProgressBar_hasHeightForWidth_bool_QProgressBar, Return,
                "bool", Parameters, new Param(c, "this", "qt.QProgressBar"),
                End),
            _func[6] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QProgressBar_heightForWidth_int_QProgressBar_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "w", "int"), End),
            _func[7] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QProgressBar_inputMethodQuery_QVariant_QProgressBar_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "query", "int"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QProgressBar this)
            // MISSING: actionEvent (void; QProgressBar this, "QActionEvent *"
            // event) // protected
            _func[8] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QProgressBar_changeEvent_void_QProgressBar_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[9] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QProgressBar_closeEvent_void_QProgressBar_QCloseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[10] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QProgressBar_contextMenuEvent_void_QProgressBar_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[11] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QProgressBar_dragEnterEvent_void_QProgressBar_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[12] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QProgressBar_dragLeaveEvent_void_QProgressBar_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[13] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QProgressBar_dragMoveEvent_void_QProgressBar_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[14] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QProgressBar_dropEvent_void_QProgressBar_QDropEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QProgressBar this, "QEnterEvent *"
            // event) // protected
            _func[15] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QProgressBar_focusInEvent_void_QProgressBar_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[16] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QProgressBar_focusNextPrevChild_bool_QProgressBar_bool,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "next", "bool"), End),
            _func[17] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QProgressBar_focusOutEvent_void_QProgressBar_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[18] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QProgressBar_hideEvent_void_QProgressBar_QHideEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QProgressBar this,
            // "QInputMethodEvent *" event) // protected
            _func[19] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QProgressBar_keyPressEvent_void_QProgressBar_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[20] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QProgressBar_keyReleaseEvent_void_QProgressBar_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[21] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QProgressBar_leaveEvent_void_QProgressBar_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[22] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QProgressBar_mouseDoubleClickEvent_void_QProgressBar_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[23] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QProgressBar_mouseMoveEvent_void_QProgressBar_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QProgressBar_mousePressEvent_void_QProgressBar_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[25] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QProgressBar_mouseReleaseEvent_void_QProgressBar_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[26] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QProgressBar_moveEvent_void_QProgressBar_QMoveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QProgressBar this, QByteArray
            // eventType, "void *" message, "qintptr *" result) // protected
            _func[27] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QProgressBar_resizeEvent_void_QProgressBar_QResizeEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[28] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QProgressBar_showEvent_void_QProgressBar_QShowEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[29] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QProgressBar_tabletEvent_void_QProgressBar_QTabletEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            _func[30] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QProgressBar_wheelEvent_void_QProgressBar_QWheelEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            // MISSING: initPainter (void; QProgressBar this, "QPainter *"
            // painter) // protected
            _func[31] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QProgressBar_metric_int_QProgressBar_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QProgressBar"),
                new Param(c, "m", "int"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char* propExclusions[] = {"text", 0};

        populate(this, QProgressBar::staticMetaObject, propExclusions);
    }

} // namespace Mu
