//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QTimerType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QTimer::~MuQt_QTimer()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QTimer::MuQt_QTimer(Pointer muobj, const CallEnvironment* ce,
                             QObject* parent)
        : QTimer(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QTimerType>(
            c->internName("qt.QTimer"));
    }

    void MuQt_QTimer::timerEvent(QTimerEvent* e)
    {
        if (!_env)
        {
            QTimer::timerEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QTimerEventType>(c, e, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTimer::timerEvent(e);
        }
    }

    bool MuQt_QTimer::event(QEvent* e)
    {
        if (!_env)
            return QTimer::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTimer::event(e);
        }
    }

    bool MuQt_QTimer::eventFilter(QObject* watched, QEvent* event)
    {
        if (!_env)
            return QTimer::eventFilter(watched, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QObjectType>(c, watched, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTimer::eventFilter(watched, event);
        }
    }

    void MuQt_QTimer::customEvent(QEvent* event)
    {
        if (!_env)
        {
            QTimer::customEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTimer::customEvent(event);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QTimerType::QTimerType(Context* c, const char* name, Class* super,
                           Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QTimerType::~QTimerType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QTimer_QTimer_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QTimer* w = object<QTimer>(widget))
        {
            QTimerType* type = c->findSymbolOfTypeByQualifiedName<QTimerType>(
                c->internName("qt.QTimer"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QTimer_QTimer_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QTimer_QTimer_QTimer_QTimer_QObject(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this,
                                                   Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QObject* arg1 = object<QObject>(param_parent);
        setobject(param_this,
                  new MuQt_QTimer(param_this, NODE_THREAD.process()->callEnv(),
                                  arg1));
        return param_this;
    }

    bool qt_QTimer_isActive_bool_QTimer(Mu::Thread& NODE_THREAD,
                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        return arg0->isActive();
    }

    void qt_QTimer_start_void_QTimer_int(Mu::Thread& NODE_THREAD,
                                         Pointer param_this, int param_msec)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        std::chrono::milliseconds arg1 =
            (std::chrono::milliseconds)(param_msec);
        arg0->start(arg1);
    }

    int qt_QTimer_timerId_int_QTimer(Mu::Thread& NODE_THREAD,
                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        return arg0->timerId();
    }

    void qt_QTimer_timerEvent_void_QTimer_QTimerEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTimer*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QTimer*)arg0)->timerEvent_pub(arg1);
    }

    bool qt_QTimer_event_bool_QTimer_QEvent(Mu::Thread& NODE_THREAD,
                                            Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0) ? arg0->QTimer::event(arg1)
                                  : arg0->event(arg1);
    }

    bool qt_QTimer_eventFilter_bool_QTimer_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_watched,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        QObject* arg1 = object<QObject>(param_watched);
        QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0) ? arg0->QTimer::eventFilter(arg1, arg2)
                                  : arg0->eventFilter(arg1, arg2);
    }

    void qt_QTimer_customEvent_void_QTimer_QEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTimer* arg0 = object<QTimer>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTimer*)arg0)->customEvent_pub_parent(arg1);
        else
            ((MuQt_QTimer*)arg0)->customEvent_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QTimer0, Pointer)
    {
        NODE_RETURN(qt_QTimer_QTimer_QTimer_QTimer_QObject(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isActive0, bool)
    {
        NODE_RETURN(qt_QTimer_isActive_bool_QTimer(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_start0, void)
    {
        qt_QTimer_start_void_QTimer_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_timerId0, int)
    {
        NODE_RETURN(qt_QTimer_timerId_int_QTimer(NODE_THREAD,
                                                 NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QTimer_timerEvent_void_QTimer_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QTimer_event_bool_QTimer_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(qt_QTimer_eventFilter_bool_QTimer_QObject_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_customEvent0, void)
    {
        qt_QTimer_customEvent_void_QTimer_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    void QTimerType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QTimer_QTimer_QObject, Return, ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QTimer", _n_QTimer0, None, Compiled,
                         qt_QTimer_QTimer_QTimer_QTimer_QObject, Return,
                         "qt.QTimer", Parameters,
                         new Param(c, "this", "qt.QTimer"),
                         new Param(c, "parent", "qt.QObject"), End),
            // MISSING: bindableActive ("QBindable<bool>"; QTimer this)
            // MISSING: bindableInterval ("QBindable<int>"; QTimer this)
            // MISSING: bindableSingleShot ("QBindable<bool>"; QTimer this)
            // PROP: bindableTimerType (flags QBindable<Qt::TimerType>; QTimer
            // this) MISSING: callOnTimeout (flags QMetaObject::Connection;
            // QTimer this, QObject context, "Functor" slot, flags
            // Qt::ConnectionType connectionType) MISSING: callOnTimeout (flags
            // QMetaObject::Connection; QTimer this, QObject receiver,
            // "MemberFunction *" slot, flags Qt::ConnectionType connectionType)
            // PROP: interval (int; QTimer this)
            new Function(c, "isActive", _n_isActive0, None, Compiled,
                         qt_QTimer_isActive_bool_QTimer, Return, "bool",
                         Parameters, new Param(c, "this", "qt.QTimer"), End),
            // PROP: isSingleShot (bool; QTimer this)
            // PROP: remainingTime (int; QTimer this)
            // PROP: setInterval (void; QTimer this, int msec)
            // MISSING: setInterval (void; QTimer this, flags
            // std::chrono::milliseconds value) PROP: setSingleShot (void;
            // QTimer this, bool singleShot) PROP: setTimerType (void; QTimer
            // this, flags Qt::TimerType atype)
            new Function(c, "start", _n_start0, None, Compiled,
                         qt_QTimer_start_void_QTimer_int, Return, "void",
                         Parameters, new Param(c, "this", "qt.QTimer"),
                         new Param(c, "msec", "int"), End),
            new Function(c, "timerId", _n_timerId0, None, Compiled,
                         qt_QTimer_timerId_int_QTimer, Return, "int",
                         Parameters, new Param(c, "this", "qt.QTimer"), End),
            // PROP: timerType (flags Qt::TimerType; QTimer this)
            _func[0] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QTimer_timerEvent_void_QTimer_QTimerEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QTimer"),
                new Param(c, "e", "qt.QTimerEvent"), End),
            _func[1] = new MemberFunction(c, "event", _n_event0, None, Compiled,
                                          qt_QTimer_event_bool_QTimer_QEvent,
                                          Return, "bool", Parameters,
                                          new Param(c, "this", "qt.QTimer"),
                                          new Param(c, "e", "qt.QEvent"), End),
            _func[2] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QTimer_eventFilter_bool_QTimer_QObject_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTimer"),
                new Param(c, "watched", "qt.QObject"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: metaObject ("const QMetaObject *"; QTimer this)
            // MISSING: childEvent (void; QTimer this, "QChildEvent *" event) //
            // protected MISSING: connectNotify (void; QTimer this, "const
            // QMetaMethod &" signal) // protected
            _func[3] = new MemberFunction(
                c, "customEvent", _n_customEvent0, None, Compiled,
                qt_QTimer_customEvent_void_QTimer_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QTimer"),
                new Param(c, "event", "qt.QEvent"), End),
            // MISSING: disconnectNotify (void; QTimer this, "const QMetaMethod
            // &" signal) // protected static functions MISSING: singleShot
            // (void; int msec, QObject receiver, "const char *" member)
            // MISSING: singleShot (void; int msec, flags Qt::TimerType
            // timerType, QObject receiver, "const char *" member) MISSING:
            // singleShot (void; int msec, QObject receiver,
            // "PointerToMemberFunction" method) MISSING: singleShot (void; int
            // msec, flags Qt::TimerType timerType, QObject receiver,
            // "PointerToMemberFunction" method) MISSING: singleShot (void; int
            // msec, "Functor" functor) MISSING: singleShot (void; int msec,
            // flags Qt::TimerType timerType, "Functor" functor) MISSING:
            // singleShot (void; int msec, QObject context, "Functor" functor)
            // MISSING: singleShot (void; int msec, flags Qt::TimerType
            // timerType, QObject context, "Functor" functor) MISSING:
            // singleShot (void; flags std::chrono::milliseconds msec, QObject
            // receiver, "const char *" member) MISSING: singleShot (void; flags
            // std::chrono::milliseconds msec, flags Qt::TimerType timerType,
            // QObject receiver, "const char *" member)
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QTimer::staticMetaObject, propExclusions);
    }

} // namespace Mu
