//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QToolBarType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QPointType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QHideEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QResizeEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QToolBar::~MuQt_QToolBar()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QToolBar::MuQt_QToolBar(Pointer muobj, const CallEnvironment* ce,
                                 const QString& title, QWidget* parent)
        : QToolBar(title, parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QToolBarType>(
            c->internName("qt.QToolBar"));
    }

    MuQt_QToolBar::MuQt_QToolBar(Pointer muobj, const CallEnvironment* ce,
                                 QWidget* parent)
        : QToolBar(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QToolBarType>(
            c->internName("qt.QToolBar"));
    }

    void MuQt_QToolBar::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QToolBar::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::changeEvent(event);
        }
    }

    bool MuQt_QToolBar::event(QEvent* event_)
    {
        if (!_env)
            return QToolBar::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QToolBar::event(event_);
        }
    }

    void MuQt_QToolBar::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QToolBar::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::paintEvent(event);
        }
    }

    bool MuQt_QToolBar::hasHeightForWidth() const
    {
        if (!_env)
            return QToolBar::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QToolBar::hasHeightForWidth();
        }
    }

    int MuQt_QToolBar::heightForWidth(int w) const
    {
        if (!_env)
            return QToolBar::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QToolBar::heightForWidth(w);
        }
    }

    QVariant MuQt_QToolBar::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QToolBar::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QToolBar::inputMethodQuery(query);
        }
    }

    QSize MuQt_QToolBar::minimumSizeHint() const
    {
        if (!_env)
            return QToolBar::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QToolBar::minimumSizeHint();
        }
    }

    QSize MuQt_QToolBar::sizeHint() const
    {
        if (!_env)
            return QToolBar::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QToolBar::sizeHint();
        }
    }

    void MuQt_QToolBar::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QToolBar::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::closeEvent(event);
        }
    }

    void MuQt_QToolBar::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QToolBar::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::contextMenuEvent(event);
        }
    }

    void MuQt_QToolBar::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QToolBar::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::dragEnterEvent(event);
        }
    }

    void MuQt_QToolBar::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QToolBar::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::dragLeaveEvent(event);
        }
    }

    void MuQt_QToolBar::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QToolBar::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::dragMoveEvent(event);
        }
    }

    void MuQt_QToolBar::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QToolBar::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::dropEvent(event);
        }
    }

    void MuQt_QToolBar::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QToolBar::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::focusInEvent(event);
        }
    }

    bool MuQt_QToolBar::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QToolBar::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QToolBar::focusNextPrevChild(next);
        }
    }

    void MuQt_QToolBar::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QToolBar::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::focusOutEvent(event);
        }
    }

    void MuQt_QToolBar::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QToolBar::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::hideEvent(event);
        }
    }

    void MuQt_QToolBar::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QToolBar::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::keyPressEvent(event);
        }
    }

    void MuQt_QToolBar::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QToolBar::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::keyReleaseEvent(event);
        }
    }

    void MuQt_QToolBar::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QToolBar::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::leaveEvent(event);
        }
    }

    void MuQt_QToolBar::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QToolBar::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QToolBar::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QToolBar::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::mouseMoveEvent(event);
        }
    }

    void MuQt_QToolBar::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QToolBar::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::mousePressEvent(event);
        }
    }

    void MuQt_QToolBar::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QToolBar::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::mouseReleaseEvent(event);
        }
    }

    void MuQt_QToolBar::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QToolBar::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::moveEvent(event);
        }
    }

    void MuQt_QToolBar::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QToolBar::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::resizeEvent(event);
        }
    }

    void MuQt_QToolBar::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QToolBar::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::showEvent(event);
        }
    }

    void MuQt_QToolBar::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QToolBar::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::tabletEvent(event);
        }
    }

    void MuQt_QToolBar::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QToolBar::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QToolBar::wheelEvent(event);
        }
    }

    int MuQt_QToolBar::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QToolBar::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QToolBar::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QToolBarType::QToolBarType(Context* c, const char* name, Class* super,
                               Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QToolBarType::~QToolBarType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QToolBar_QToolBar_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QToolBar* w = object<QToolBar>(widget))
        {
            QToolBarType* type =
                c->findSymbolOfTypeByQualifiedName<QToolBarType>(
                    c->internName("qt.QToolBar"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(
            QToolBar_QToolBar_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QToolBar_QToolBar_QToolBar_QToolBar_string_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_title,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QString arg1 = qstring(param_title);
        QWidget* arg2 = object<QWidget>(param_parent);
        setobject(param_this, new MuQt_QToolBar(
                                  param_this, NODE_THREAD.process()->callEnv(),
                                  arg1, arg2));
        return param_this;
    }

    Pointer qt_QToolBar_QToolBar_QToolBar_QToolBar_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QToolBar(param_this,
                                    NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer qt_QToolBar_actionAt_QAction_QToolBar_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_p)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_p);
        return makeinstance<QActionType>(c, arg0->actionAt(arg1), "qt.QAction");
    }

    Pointer qt_QToolBar_actionAt_QAction_QToolBar_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_x, int param_y)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        int arg1 = (int)(param_x);
        int arg2 = (int)(param_y);
        return makeinstance<QActionType>(c, arg0->actionAt(arg1, arg2),
                                         "qt.QAction");
    }

    Pointer qt_QToolBar_addSeparator_QAction_QToolBar(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        return makeinstance<QActionType>(c, arg0->addSeparator(), "qt.QAction");
    }

    Pointer qt_QToolBar_addWidget_QAction_QToolBar_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QWidget* arg1 = object<QWidget>(param_widget);
        return makeinstance<QActionType>(c, arg0->addWidget(arg1),
                                         "qt.QAction");
    }

    void qt_QToolBar_clear_void_QToolBar(Mu::Thread& NODE_THREAD,
                                         Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        arg0->clear();
    }

    Pointer qt_QToolBar_insertSeparator_QAction_QToolBar_QAction(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        return makeinstance<QActionType>(c, arg0->insertSeparator(arg1),
                                         "qt.QAction");
    }

    Pointer qt_QToolBar_insertWidget_QAction_QToolBar_QAction_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before,
        Pointer param_widget)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        QWidget* arg2 = object<QWidget>(param_widget);
        return makeinstance<QActionType>(c, arg0->insertWidget(arg1, arg2),
                                         "qt.QAction");
    }

    bool qt_QToolBar_isAreaAllowed_bool_QToolBar_int(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     int param_area)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        Qt::ToolBarArea arg1 = (Qt::ToolBarArea)(param_area);
        return arg0->isAreaAllowed(arg1);
    }

    Pointer
    qt_QToolBar_toggleViewAction_QAction_QToolBar(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        return makeinstance<QActionType>(c, arg0->toggleViewAction(),
                                         "qt.QAction");
    }

    Pointer qt_QToolBar_widgetForAction_QWidget_QToolBar_QAction(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_action)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QAction* arg1 = object<QAction>(param_action);
        return makeinstance<QWidgetType>(c, arg0->widgetForAction(arg1),
                                         "qt.QWidget");
    }

    void qt_QToolBar_changeEvent_void_QToolBar_QEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->changeEvent_pub(arg1);
    }

    bool qt_QToolBar_event_bool_QToolBar_QEvent(Mu::Thread& NODE_THREAD,
                                                Pointer param_this,
                                                Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QToolBar*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QToolBar*)arg0)->event_pub(arg1);
    }

    void qt_QToolBar_paintEvent_void_QToolBar_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->paintEvent_pub(arg1);
    }

    bool qt_QToolBar_hasHeightForWidth_bool_QToolBar(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        return isMuQtObject(arg0) ? arg0->QToolBar::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QToolBar_heightForWidth_int_QToolBar_int(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QToolBar::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QToolBar_inputMethodQuery_QVariant_QToolBar_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QToolBar::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer qt_QToolBar_minimumSizeHint_QSize_QToolBar(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QToolBar::minimumSizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer qt_QToolBar_sizeHint_QSize_QToolBar(Mu::Thread& NODE_THREAD,
                                                Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QToolBar::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    void qt_QToolBar_closeEvent_void_QToolBar_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->closeEvent_pub(arg1);
    }

    void qt_QToolBar_contextMenuEvent_void_QToolBar_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QToolBar_dragEnterEvent_void_QToolBar_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QToolBar_dragLeaveEvent_void_QToolBar_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QToolBar_dragMoveEvent_void_QToolBar_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QToolBar_dropEvent_void_QToolBar_QDropEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QToolBar_focusInEvent_void_QToolBar_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QToolBar_focusNextPrevChild_bool_QToolBar_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QToolBar*)arg0)->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QToolBar*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QToolBar_focusOutEvent_void_QToolBar_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QToolBar_hideEvent_void_QToolBar_QHideEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QToolBar_keyPressEvent_void_QToolBar_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QToolBar_keyReleaseEvent_void_QToolBar_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QToolBar_leaveEvent_void_QToolBar_QEvent(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->leaveEvent_pub(arg1);
    }

    void qt_QToolBar_mouseDoubleClickEvent_void_QToolBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QToolBar_mouseMoveEvent_void_QToolBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QToolBar_mousePressEvent_void_QToolBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QToolBar_mouseReleaseEvent_void_QToolBar_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QToolBar_moveEvent_void_QToolBar_QMoveEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QToolBar_resizeEvent_void_QToolBar_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QToolBar_showEvent_void_QToolBar_QShowEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->showEvent_pub(arg1);
    }

    void qt_QToolBar_tabletEvent_void_QToolBar_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->tabletEvent_pub(arg1);
    }

    void qt_QToolBar_wheelEvent_void_QToolBar_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QToolBar*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QToolBar*)arg0)->wheelEvent_pub(arg1);
    }

    int qt_QToolBar_metric_int_QToolBar_int(Mu::Thread& NODE_THREAD,
                                            Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QToolBar* arg0 = object<QToolBar>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QToolBar*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QToolBar*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QToolBar0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_QToolBar_QToolBar_QToolBar_string_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_QToolBar1, Pointer)
    {
        NODE_RETURN(qt_QToolBar_QToolBar_QToolBar_QToolBar_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_actionAt0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_actionAt_QAction_QToolBar_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_actionAt1, Pointer)
    {
        NODE_RETURN(qt_QToolBar_actionAt_QAction_QToolBar_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_addSeparator0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_addSeparator_QAction_QToolBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addWidget0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_addWidget_QAction_QToolBar_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clear0, void)
    {
        qt_QToolBar_clear_void_QToolBar(NODE_THREAD,
                                        NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_insertSeparator0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_insertSeparator_QAction_QToolBar_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertWidget0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_insertWidget_QAction_QToolBar_QAction_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isAreaAllowed0, bool)
    {
        NODE_RETURN(qt_QToolBar_isAreaAllowed_bool_QToolBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_toggleViewAction0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_toggleViewAction_QAction_QToolBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_widgetForAction0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_widgetForAction_QWidget_QToolBar_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QToolBar_changeEvent_void_QToolBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QToolBar_event_bool_QToolBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QToolBar_paintEvent_void_QToolBar_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QToolBar_hasHeightForWidth_bool_QToolBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QToolBar_heightForWidth_int_QToolBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_inputMethodQuery_QVariant_QToolBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_minimumSizeHint_QSize_QToolBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QToolBar_sizeHint_QSize_QToolBar(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QToolBar_closeEvent_void_QToolBar_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QToolBar_contextMenuEvent_void_QToolBar_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QToolBar_dragEnterEvent_void_QToolBar_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QToolBar_dragLeaveEvent_void_QToolBar_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QToolBar_dragMoveEvent_void_QToolBar_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QToolBar_dropEvent_void_QToolBar_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QToolBar_focusInEvent_void_QToolBar_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QToolBar_focusNextPrevChild_bool_QToolBar_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QToolBar_focusOutEvent_void_QToolBar_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QToolBar_hideEvent_void_QToolBar_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QToolBar_keyPressEvent_void_QToolBar_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QToolBar_keyReleaseEvent_void_QToolBar_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QToolBar_leaveEvent_void_QToolBar_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QToolBar_mouseDoubleClickEvent_void_QToolBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QToolBar_mouseMoveEvent_void_QToolBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QToolBar_mousePressEvent_void_QToolBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QToolBar_mouseReleaseEvent_void_QToolBar_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QToolBar_moveEvent_void_QToolBar_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QToolBar_resizeEvent_void_QToolBar_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QToolBar_showEvent_void_QToolBar_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QToolBar_tabletEvent_void_QToolBar_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QToolBar_wheelEvent_void_QToolBar_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QToolBar_metric_int_QToolBar_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QToolBarType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QToolBar_QToolBar_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QToolBar", _n_QToolBar0, None, Compiled,
                         qt_QToolBar_QToolBar_QToolBar_QToolBar_string_QWidget,
                         Return, "qt.QToolBar", Parameters,
                         new Param(c, "this", "qt.QToolBar"),
                         new Param(c, "title", "string"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(c, "QToolBar", _n_QToolBar1, None, Compiled,
                         qt_QToolBar_QToolBar_QToolBar_QToolBar_QWidget, Return,
                         "qt.QToolBar", Parameters,
                         new Param(c, "this", "qt.QToolBar"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(c, "actionAt", _n_actionAt0, None, Compiled,
                         qt_QToolBar_actionAt_QAction_QToolBar_QPoint, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QToolBar"),
                         new Param(c, "p", "qt.QPoint"), End),
            new Function(
                c, "actionAt", _n_actionAt1, None, Compiled,
                qt_QToolBar_actionAt_QAction_QToolBar_int_int, Return,
                "qt.QAction", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "x", "int"), new Param(c, "y", "int"), End),
            new Function(c, "addSeparator", _n_addSeparator0, None, Compiled,
                         qt_QToolBar_addSeparator_QAction_QToolBar, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QToolBar"), End),
            new Function(c, "addWidget", _n_addWidget0, None, Compiled,
                         qt_QToolBar_addWidget_QAction_QToolBar_QWidget, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QToolBar"),
                         new Param(c, "widget", "qt.QWidget"), End),
            // PROP: allowedAreas (flags Qt::ToolBarAreas; QToolBar this)
            new Function(c, "clear", _n_clear0, None, Compiled,
                         qt_QToolBar_clear_void_QToolBar, Return, "void",
                         Parameters, new Param(c, "this", "qt.QToolBar"), End),
            // PROP: iconSize (QSize; QToolBar this)
            new Function(
                c, "insertSeparator", _n_insertSeparator0, None, Compiled,
                qt_QToolBar_insertSeparator_QAction_QToolBar_QAction, Return,
                "qt.QAction", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "before", "qt.QAction"), End),
            new Function(
                c, "insertWidget", _n_insertWidget0, None, Compiled,
                qt_QToolBar_insertWidget_QAction_QToolBar_QAction_QWidget,
                Return, "qt.QAction", Parameters,
                new Param(c, "this", "qt.QToolBar"),
                new Param(c, "before", "qt.QAction"),
                new Param(c, "widget", "qt.QWidget"), End),
            new Function(c, "isAreaAllowed", _n_isAreaAllowed0, None, Compiled,
                         qt_QToolBar_isAreaAllowed_bool_QToolBar_int, Return,
                         "bool", Parameters,
                         new Param(c, "this", "qt.QToolBar"),
                         new Param(c, "area", "int"), End),
            // PROP: isFloatable (bool; QToolBar this)
            // PROP: isFloating (bool; QToolBar this)
            // PROP: isMovable (bool; QToolBar this)
            // PROP: orientation (flags Qt::Orientation; QToolBar this)
            // PROP: setAllowedAreas (void; QToolBar this, flags
            // Qt::ToolBarAreas areas) PROP: setFloatable (void; QToolBar this,
            // bool floatable) PROP: setMovable (void; QToolBar this, bool
            // movable) PROP: setOrientation (void; QToolBar this, flags
            // Qt::Orientation orientation)
            new Function(c, "toggleViewAction", _n_toggleViewAction0, None,
                         Compiled,
                         qt_QToolBar_toggleViewAction_QAction_QToolBar, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QToolBar"), End),
            // PROP: toolButtonStyle (flags Qt::ToolButtonStyle; QToolBar this)
            new Function(
                c, "widgetForAction", _n_widgetForAction0, None, Compiled,
                qt_QToolBar_widgetForAction_QWidget_QToolBar_QAction, Return,
                "qt.QWidget", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "action", "qt.QAction"), End),
            // MISSING: actionEvent (void; QToolBar this, "QActionEvent *"
            // event) // protected
            _func[0] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QToolBar_changeEvent_void_QToolBar_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[1] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QToolBar_event_bool_QToolBar_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event_", "qt.QEvent"), End),
            _func[2] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QToolBar_paintEvent_void_QToolBar_QPaintEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[3] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QToolBar_hasHeightForWidth_bool_QToolBar, Return, "bool",
                Parameters, new Param(c, "this", "qt.QToolBar"), End),
            _func[4] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QToolBar_heightForWidth_int_QToolBar_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "w", "int"), End),
            _func[5] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QToolBar_inputMethodQuery_QVariant_QToolBar_int, Return,
                "qt.QVariant", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "query", "int"), End),
            _func[6] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QToolBar_minimumSizeHint_QSize_QToolBar, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QToolBar"), End),
            _func[7] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QToolBar_sizeHint_QSize_QToolBar, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QToolBar"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QToolBar this)
            _func[8] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QToolBar_closeEvent_void_QToolBar_QCloseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[9] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QToolBar_contextMenuEvent_void_QToolBar_QContextMenuEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[10] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QToolBar_dragEnterEvent_void_QToolBar_QDragEnterEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[11] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QToolBar_dragLeaveEvent_void_QToolBar_QDragLeaveEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[12] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QToolBar_dragMoveEvent_void_QToolBar_QDragMoveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[13] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QToolBar_dropEvent_void_QToolBar_QDropEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QToolBar this, "QEnterEvent *" event)
            // // protected
            _func[14] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QToolBar_focusInEvent_void_QToolBar_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[15] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QToolBar_focusNextPrevChild_bool_QToolBar_bool, Return,
                "bool", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "next", "bool"), End),
            _func[16] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QToolBar_focusOutEvent_void_QToolBar_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[17] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QToolBar_hideEvent_void_QToolBar_QHideEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QToolBar this,
            // "QInputMethodEvent *" event) // protected
            _func[18] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QToolBar_keyPressEvent_void_QToolBar_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[19] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QToolBar_keyReleaseEvent_void_QToolBar_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[20] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QToolBar_leaveEvent_void_QToolBar_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[21] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QToolBar_mouseDoubleClickEvent_void_QToolBar_QMouseEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[22] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QToolBar_mouseMoveEvent_void_QToolBar_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[23] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QToolBar_mousePressEvent_void_QToolBar_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QToolBar_mouseReleaseEvent_void_QToolBar_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[25] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QToolBar_moveEvent_void_QToolBar_QMoveEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QToolBar this, QByteArray eventType,
            // "void *" message, "qintptr *" result) // protected
            _func[26] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QToolBar_resizeEvent_void_QToolBar_QResizeEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[27] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QToolBar_showEvent_void_QToolBar_QShowEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[28] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QToolBar_tabletEvent_void_QToolBar_QTabletEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            _func[29] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QToolBar_wheelEvent_void_QToolBar_QWheelEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QToolBar"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            // MISSING: initPainter (void; QToolBar this, "QPainter *" painter)
            // // protected
            _func[30] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QToolBar_metric_int_QToolBar_int, Return, "int", Parameters,
                new Param(c, "this", "qt.QToolBar"), new Param(c, "m", "int"),
                End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QToolBar::staticMetaObject, propExclusions);
    }

} // namespace Mu
